<?php
/*
Plugin Name: HP WallArt Plugin
Plugin URI: https://hpwallart.com/developers/wordpress_plugin/en
Description: Quick and easy creation of an e-commerce website for products HP WallArt. Built in Wordpress by WooCommerce ecommerce plugin, allows configuration and the added features of the basic and advanced settings to configure the system. It also allows the connection to the bank system Fotolia photos to create custom image galleries, and create customized products.<strong> Note: To support multiple orders in cart, you need to do some changes in Woocommerce plugin files. More Details <a href="https://s3.amazonaws.com/diego-production/word_press_plugin/v5.6.3/Readme.doc" target="_blank">Read Me</a> | <a href="https://s3.amazonaws.com/diego-production/word_press_plugin/v5.6.3/AdditionalFiles.zip" target="_blank">Download files</a></strong>
Author: Hewlett Packard
Version: 5.7.5
Author URI: https://hpwallart.com/developers/wordpress_plugin/en
Text Domain: hpwallart
WC requires at least: 3.0.0
WC tested up to: 4.1
*/
/**
     @contact   HP WallArt Barcelona Team (abad@hp.com)
 
     @version   5.7.5
     @date October 14 2020
 
*   (c) Copyright 2018 Hewlett-Packard Development Company L.P
*   All rights reserved. Copying or other reproduction of this
*   program except for archival purposes is prohibited without
*   written consent of HP Inc.
*
*   HP / GSB / LFPro
*/
	ini_set('display_errors','Off');
	ini_set('error_reporting', E_ALL );
	//AUTO UPDATE THE PLUGIN FROM THE REPOSITORY
	require 'plugin-updates/plugin-update-checker.php';
	$MyUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
		'https://hpwallart.com/wordpress/updates/info.json',
		__FILE__,
		'hpwallart'
	);
	
	set_time_limit(0);

	class HPWallart 
	{
		/**
         *A Unique Identifier
         */
		protected $plugin_slug;

        /**
         *A reference to an instance of this class.
         */
        private static $instance;

        /**
         *The array of templates that this plugin tracks.
         */
        protected $templates;

		var $version_plugin = '5.7.5';

        /**
         *Returns an instance of this class. 
         */
        public static function get_instance() {

                if( null == self::$instance ) {
                        self::$instance = new HPWallart();
                }

                return self::$instance;

        }

        /**
         *Initializes the plugin by setting filters and administration functions.
         */
        private function __construct() 
		{
			require_once(dirname( __FILE__ ) . '/includes/classes/class-tgm-plugin-activation.php');
			
			add_action('woocommerce_locate_template', array($this, 'myplugin_woocommerce_locate_template'), 10, 3);	 
			add_action('wp_enqueue_script', array($this, 'remove_custom_scripts'),5);  
			add_action('admin_menu', array($this, 'hp_add_pages'), 5);
			add_filter('plugin_action_links_' . plugin_basename(__FILE__), array($this, 'my_plugin_action_links') );
			
			add_filter('woocommerce_add_cart_item_data', array($this, 'hpwallart_add_item_data'),1,2);
			add_filter('woocommerce_get_cart_item_from_session', array($this, 'hpwallart_get_cart_items_from_session'), 1, 3 );
						
			//add_filter('woocommerce_checkout_cart_item_quantity', array($this, 'hpwallart_add_user_custom_option_from_session_into_cart'),1,3);  
			add_filter('woocommerce_get_item_data', array($this, 'hpwallart_add_user_custom_option_from_session_into_cart'),1,2);  
						
			//add_filter('woocommerce_cart_item_price', array($this, 'hpwallart_add_user_custom_option_from_session_into_cart'),1,2);
			add_action('woocommerce_add_order_item_meta', array($this, 'hpwallart_add_values_to_order_item_meta'),1,2);
			add_action('woocommerce_before_cart_item_quantity_zero', array($this, 'hpwallart_remove_user_custom_data_options_from_cart'),1,1);
			
			add_action('woocommerce_remove_cart_item', array($this, 'hpwallart_remove_session'), 10, 2 );
			
			//add_action('init', array($this, 'redirection_function'));
	
			add_action('woocommerce_cart_calculate_fees', array($this, 'hpwallart_woocommerce_custom_surcharge'), 5 );
			
			add_action( 'woocommerce_before_calculate_totals', array($this, 'add_custom_price'), 99, 1 );
			

			add_action('init', array($this, 'add_categories_for_attachments') );
			add_action('init', array($this, 'add_tags_for_attachments') );
			
			add_action('init', array($this, 'set_page_principal') );
			add_action('init', array($this, 'create_media_categories') );
						
			add_action('tgmpa_register', array($this, 'my_theme_register_required_plugins') );
			
			add_action( 'admin_enqueue_scripts', array($this, 'mw_enqueue_color_picker') );
			
			add_filter( 'woocommerce_cart_item_name', array($this, 'cart_variation_description'), 20, 3);
			
			//plugins upgrade
			add_action( 'upgrader_process_complete', array($this, 'createItem'),10, 2);

			//add_action('init', array($this, 'wpse_insert_term'),10, 2);
			
			add_filter('woocommerce_hidden_order_itemmeta', array($this, 'hpwallart_woocommerce_hidden_order_itemmeta'), 10, 1);
			
        }

		//hide some order item meta
		public function hpwallart_woocommerce_hidden_order_itemmeta($arr) {
			$arr[] = '_data';
			$arr[] = '_status';
			return $arr;
		}
		
		public function cart_variation_description( $title, $cart_item, $cart_item_key ) {
			$item = $cart_item['data'];
		
			if(!empty($item) && $item->is_type( 'variation' ) ) {
				$result = __('Description: ','hpwallart') . $item->get_variation_description();
				return $title . '<br>' . $result;
			} else
				return $title;
		}

		public function hpwallart_remove_session( $cart_item_key, $cart ) {
			session_start();
			unset($_SESSION["basket"]);
			unset($_SESSION);
			session_destroy();
			$_SESSION['basket']['paso'] = '1';
		}
		
		//ADDS THE POSIBILITY OF USE CATEGORIES AND TAGS IN ATTACHMENTS
		// add categories for attachments
		public function add_categories_for_attachments() {
			register_taxonomy_for_object_type( 'category', 'attachment' );
		}
		
		// add tags for attachments
		public function add_tags_for_attachments() {
			register_taxonomy_for_object_type( 'post_tag', 'attachment' );
		}
		
		//FUNCTIONS TO ADD TO CART CUSTOM DATA
		//Add fee to cart, production
		 
		//2: Add Custom Data in WooCommerce Session
		public function hpwallart_add_item_data($cart_item_data, $product_id)
		{
			/*Here, We are adding item in WooCommerce session with, hpwallart_user_custom_data_value name*/
			global $woocommerce;
			
			$data = (array) WC()->session->get('_lm_product_data');
			session_start();    
			if (isset($data)) {
				$option = $data;       
				$new_value = array('hpwallart_user_custom_data_value' => $option);
			}
			if(empty($option))
				return $cart_item_data;
			else
			{    
				if(empty($cart_item_data))
					return $new_value;
				else
					return array_merge($cart_item_data, $new_value);
			}
		}

		//3: Extract Custom Data from WooCommerce Session and Insert it into Cart Object
		public function hpwallart_get_cart_items_from_session($item,$values,$key)
		{
			if (array_key_exists( 'hpwallart_user_custom_data_value', $values ) )
			{
				$item['hpwallart_user_custom_data_value'] = $values['hpwallart_user_custom_data_value'];
			}       
			return $item;
		}

		//4: Display User Custom Data on Cart and Checkout page
		/* Multiple Cart: Here we set a product name, width, height for produts in cart based on cart key */
		public function hpwallart_add_user_custom_option_from_session_into_cart($product_name, $values )
		{
			$meta_items = array();
			
			/*code to add custom data on Cart & checkout Page*/  
			$hpwallart_unit_system = get_option('hpwallart_unit_system');


			if($hpwallart_unit_system == 'Imperial')
			{
				 $unit = 'in';
			}
			elseif($hpwallart_unit_system == 'Metric')
			{
				 $unit = 'cm';
			}

			if( !empty( $cart_data ) ) {
				$meta_items = $cart_data;
			}
			
			/* Multiple Cart: START>>> */
			$key = $_SESSION['cart_id'];
			$values['hpwallart_user_custom_data_value'] = (array) WC()->session->get($key);
			if(count($values['hpwallart_user_custom_data_value']) > 0)
			{
				// $meta_items[] = array( "name" => __( 'Preview', 'hpwallart' ), "value" => '<a target="_blank" href="'.$values["hpwallart_user_custom_data_value"]["_preview"].'"><i class="fa fa-external-link-square"></i> '.__( 'Preview', 'hpwallart' ).'</a>' );
				$meta_items[] = array( "name" => __( 'Name', 'hpwallart' ), "value" => $values['hpwallart_user_custom_data_value']['_name'] );
				$meta_items[] = array( "name" => __( 'Width', 'hpwallart' ), "value" => $values['hpwallart_user_custom_data_value']['_width'] );
				$meta_items[] = array( "name" => __( 'Height', 'hpwallart' ), "value" => $values['hpwallart_user_custom_data_value']['_height'] );			
		    }
			/* Multiple Cart: >>>END */
			return $meta_items;
		}

		//5: Add Custom Data as Metadata to the Order Items
		/* Multiple Cart: START>>> */
		public function hpwallart_add_values_to_order_item_meta($item_id, $values)
		{
			global $woocommerce,$wpdb;
            
			foreach ( $cart_object->cart_contents as $key => $value ) 
			{//added for loop

			// $values['hpwallart_user_custom_data_value'] = (array) WC()->session->get('_lm_product_data');
				$values['hpwallart_user_custom_data_value'] = (array) WC()->session->get($key);
				$user_custom_values = $values['hpwallart_user_custom_data_value'];
			
				if(!empty($user_custom_values))
				{
					wc_add_order_item_meta($item_id,'hpwallart_user_custom_data',$user_custom_values);  
				}
		    }
		}
        /* Multiple Cart: >>>END */
		//6. Remove User Custom Data, if Product is Removed from Cart
		public function hpwallart_remove_user_custom_data_options_from_cart($cart_item_key)
		{
			global $woocommerce;
			// Get cart
			$cart = $woocommerce->cart->get_cart();
			// For each item in cart, if item is upsell of deleted product, delete it
			foreach( $cart as $key => $values)
			{
				if ( $values['hpwallart_user_custom_data_value'] == $cart_item_key )
				{	
					unset( $woocommerce->cart->cart_contents[ $key ] );
				}
			}
		}

		//7. add fee extra for increment of the size
		public function hpwallart_woocommerce_custom_surcharge() {
		  	global $woocommerce;
		
			if ( is_admin() && ! defined( 'DOING_AJAX' ) )
				return;
			
			/* Multiple Cart: START>>> */
			// Get cart
			$cart = $woocommerce->cart->get_cart();
			foreach( $cart as $key => $values)
			{
				$qty = $values['quantity'];
			}

			$a = 0;
			$b = 0;
			$c = 0;
			$d = 0;
			foreach( $cart as $key => $image)
			{

				$data = (array) WC()->session->get($key);
				$a = $data['_fotolia'] + $a;
				$b = $data['_pattern_design'] + $b;
				$c = $data['_dreamstime'] + $c;
				$d = $data['_adobe'] + $d;
		    }
		    if($a > 0)
			{
				  $woocommerce->cart->add_fee( __('Fotolia images', 'hpwallart'), $a, true, '' );
			}

			if($b > 0)
			{
				$woocommerce->cart->add_fee( __('Pattern Design images', 'hpwallart'), $b, true, '' );
			}

			if($c > 0)
			{
				$woocommerce->cart->add_fee( __('Dreamstime images', 'hpwallart'), $c, true, '' );
			}

			if($d > 0)
			{
				$woocommerce->cart->add_fee( __('Adobe images', 'hpwallart'), $d, true, '' );
			}
			/* Multiple Cart: >>>END */		
		}

		//8. Custom price
		public function add_custom_price( $cart_object)
		{
			global $woocommerce;
			if ( is_admin() && ! defined( 'DOING_AJAX' ) )
			return;
			
            /* Multiple Cart: START>>> */

			foreach ( $cart_object->cart_contents as $key => $value )
			{

				//$value['data']->set_price($value['hpwallart_user_custom_data_value']['_price']);
				// $value2 = (array) WC()->session->get($a);
				$value2 = (array) WC()->session->get($key);
				if($key ){
					if($value2['_price'] != '')
					$value['data']->set_price($value2['_price']);
					// echo $key."\n";
					// echo "<pre>";
					// echo $value2['_price'];
					// echo "</pre>";
				}
			}

			/* Multiple Cart: >>>END */

		}
				
		public function formatC($array = NULL)
		{
			echo '<pre>';
			print_r($array);
			echo '</pre>';
		}
		
		public function my_plugin_action_links( $links ) {
		   $mylinks[] = '<a href="'. get_admin_url(null, 'admin.php?page=hpwallartsettings') .'">'.__('Settings', 'woocommerce').'</a>';
		   $mylinks[] = '<a class="thickbox" href="'. get_admin_url(null, 'plugin-install.php?tab=plugin-information&plugin=hpwallart&TB_iframe=true&width=772&height=1184') .'">'.__('Details', 'woocommerce').'</a>';
		   //$mylinks[] = '<a href="'. get_admin_url(null, 'plugin-editor.php?file=hpwallart/hpwallart.php') .'">'.__('Edit', 'woocommerce').'</a>';
		   //$links[] = '<a href="http://wp-buddy.com" target="_blank">More plugins by WP-Buddy</a>';
		   return $mylinks + $links;		   
		}

		public function hp_add_pages() {
			// Add a new submenu under Settings:
			//add_options_page(__('HP WallArt Settings','hpwallart'), __('HP WallArt Settings','hpwallart'), 'manage_options', 'hpwallartsettings', array($this,'hp_settings_page'));
			add_menu_page(__('WallArt data','hpwallart'), __('HP WallArt','hpwallart'), 'manage_options', 'wallart_settings', array($this,'wa_settings_page'), plugins_url( '/hpwallart/images/logo.png' ), '65.7');
			//add_submenu_page(__('WallArt data','hpwallart'), __('WallArt data','hpwallart'), 'manage_options', 'hpwallartdata', array($this,'hp_settings_page2'));
		
			// Add a submenu to the custom top-level menu:
			add_submenu_page('wallart_settings', __('WallArt data','hpwallart'), __('WallArt data','hpwallart'), 'manage_options', 'wallart_settings', array($this,'wa_settings_page'));
			add_submenu_page('wallart_settings', __('Settings','hpwallart'), __('Settings','hpwallart'), 'manage_options', 'hpwallartsettings', array($this,'hp_settings_page'));
			add_submenu_page('wallart_settings', __('Help','hpwallart'), __('Help','hpwallart'), 'manage_options', 'help_settings', array($this,'help_page'));
		
		}

		// hp_settings_page() displays the page content for the HP Wallart settings 
		public function hp_settings_page() 
		{
			//$this->createItem();			
			
			//load data from Database
			$data = unserialize(get_option('wallart_data'));
		?>
        	<link rel="stylesheet" href="<?php echo plugins_url( 'css/tipTip.css', __FILE__ ); ?>">
			<script src="//code.jquery.com/jquery-1.10.2.js"></script>
			<script src="<?php echo plugins_url( 'js/jquery.tipTip.js', __FILE__ ); ?>"></script>
            <script>
			$(function(){
				$(".tiptip").tipTip();
			});
			</script>
		<?php
			//must check that the user has the required capability 
			if (!current_user_can('manage_options'))
			{
			  wp_die( __('You do not have sufficient permissions to access this page.') );
			}
		
			// Read in existing option value from database
			if($_POST['active_tab'] == 'general')
			{
				if( isset($_POST['hp_submit_hidden']) && $_POST['hp_submit_hidden'] == 'Y' )
				{
					
					//$use_https = $_POST['use_https'];
					//$hpwallart_taxes = $_POST['hpwallart_taxes'];
					$set_page_principal = $_POST['set_page_principal'];
					$items_per_page = $_POST['items_per_page'];
					$number_of_scenes = $_POST['number_of_scenes'];
					$number_of_elements = $_POST['number_of_elements'];
					$active_tooltip = $_POST['active_tooltip'];
					$use_backgrounds = $_POST['use_backgrounds'];
					$use_objects = $_POST['use_objects'];
					$allow_users_upload = $_POST['allow_users_upload'];

					//update_option( 'use_https', $use_https );
					//update_option( 'hpwallart_taxes', $hpwallart_taxes );
					update_option( 'set_page_principal', $set_page_principal );
					update_option( 'items_per_page', $items_per_page );
					update_option( 'number_of_scenes', $number_of_scenes );
					update_option( 'number_of_elements', $number_of_elements );
					update_option( 'active_tooltip', $active_tooltip );
					update_option( 'use_backgrounds', $use_backgrounds );
					update_option( 'use_objects', $use_objects );
					update_option( 'allow_users_upload', $allow_users_upload );
				}
				// Put an settings updated message on the screen
			?>
				<div class="updated"><p><strong><?php _e('settings saved.', 'hpwallart' ); ?></strong></p></div>
			<?php
			}
			if($_POST['active_tab'] == 'stock')
			{
				if( isset($_POST['hp_submit_hidden']) && $_POST['hp_submit_hidden'] == 'Y' )
				{
					//$select_image_provider = $_POST['select_image_provider'];
					$fotolia_api_key = $_POST['fotolia_api_key'];
					$instagram_access_token = $_POST['instagram_access_token'];
					$big_stock_photo_account_id = $_POST['big_stock_photo_account_id'];
					$big_stock_photo_secret_key = $_POST['big_stock_photo_secret_key'];
					$pattern_design_api_key = $_POST['pattern_design_api_key'];
					$pattern_design_hmac_key = $_POST['pattern_design_hmac_key'];
					$dropbox_api_key = $_POST['dropbox_api_key'];
					$dropbox_api_secret = $_POST['dropbox_api_secret'];

					$gd_scenes_url = $_POST['gd_scenes_url'];
					$gd_objects_url = $_POST['gd_objects_url'];
					//$gd_max_depth = $_POST['gd_max_depth'];
					$dropbox_scenes_url = $_POST['dropbox_scenes_url'];
					$dropbox_objects_url = $_POST['dropbox_objects_url'];
					$dropbox_token = $_POST['dropbox_token'];
					
					//update_option( 'select_image_provider', $select_image_provider );
					update_option( 'fotolia_api_key', $fotolia_api_key );
					update_option( 'instagram_access_token', $instagram_access_token );
					update_option( 'big_stock_photo_account_id', $big_stock_photo_account_id );
					update_option( 'big_stock_photo_secret_key', $big_stock_photo_secret_key );
					update_option( 'pattern_design_api_key', $pattern_design_api_key );
					update_option( 'pattern_design_hmac_key', $pattern_design_hmac_key );
					update_option( 'dropbox_api_key', $dropbox_api_key );
					update_option( 'dropbox_api_secret', $dropbox_api_secret );

					update_option( 'gd_scenes_url', $gd_scenes_url );
					update_option( 'gd_objects_url', $gd_objects_url );
					//update_option( 'gd_max_depth', $gd_max_depth );
					update_option( 'dropbox_scenes_url', $dropbox_scenes_url );
					update_option( 'dropbox_objects_url', $dropbox_objects_url );

					update_option( 'dropbox_token', $dropbox_token );
				}
				// Put an settings updated message on the screen
			?>
				<div class="updated"><p><strong><?php _e('settings saved.', 'hpwallart' ); ?></strong></p></div>
			<?php
			}
	
			if($_POST['active_tab'] == 'sku')
			{
				//ASIGN POST DATA

				foreach($data['applications'] as $k => $v)
				{
					${"use_{$v['sku']}"} = $_POST['use_'.$v['sku']];
					${"{$v['sku']}_backgrounds"} = $_POST[$v['sku'].'_backgrounds'];
					${"{$v['sku']}_objects"} = $_POST[$v['sku'].'_objects'];
				}

				foreach($data['application_groups'] as $k2 => $v2)
				{
					foreach($v2['applications'] as $k => $v)
					{
						//$v['sku'] = strtolower(preg_replace('/\s+/', '', $v['name']));
						
						${"use_{$v['sku']}"} = $_POST['use_'.$v['sku']];
						${"{$v['sku']}_backgrounds"} = $_POST[$v['sku'].'_backgrounds'];
						${"{$v['sku']}_objects"} = $_POST[$v['sku'].'_objects'];
					}
				}
				
				// If they did, this hidden field will be set to 'Y'
				if( isset($_POST['hp_submit_hidden']) && $_POST['hp_submit_hidden'] == 'Y' )
				{
					// Save the posted value in the database

					foreach($data['applications'] as $k => $v)
					{
						update_option('use_'.$v['sku'], ${"use_{$v['sku']}"});
						update_option($v['sku'].'_backgrounds', ${"{$v['sku']}_backgrounds"});
						update_option($v['sku'].'_objects', ${"{$v['sku']}_objects"});
					}

					foreach($data['application_groups'] as $k2 => $v2)
					{
						foreach($v2['applications'] as $k => $v)
						{
							//$v['sku'] = strtolower(preg_replace('/\s+/', '', $v['name']));
							
							update_option('use_'.$v['sku'], ${"use_{$v['sku']}"});
							update_option($v['sku'].'_backgrounds', ${"{$v['sku']}_backgrounds"});
							update_option($v['sku'].'_objects', ${"{$v['sku']}_objects"});
						}
					}
				}
				// Put an settings updated message on the screen
			?>
				<div class="updated"><p><strong><?php _e('settings saved.', 'hpwallart' ); ?></strong></p></div>
			<?php
			}
			
			if($_POST['active_tab'] == 'appearance')
			{
				if(isset($_POST['appearance']))
				{
					update_option('appearance', serialize($_POST['appearance']));
				}
				
				if(isset($_POST['reset_styles']) && $_POST['reset_styles'] == '1')
				{
					update_option('appearance', NULL);
				}
				
				// Put an settings updated message on the screen
			?>
				<div class="updated"><p><strong><?php _e('settings saved.', 'hpwallart' ); ?></strong></p></div>
			<?php
			}
			if($_POST['active_tab'] == 'textconfig')
			{
				if(isset($_POST['textconfig1']))
				{
					update_option('textconfig1', $_POST['textconfig1']);
				}
				
				if(isset($_POST['textconfig2']))
				{
					update_option('textconfig2', $_POST['textconfig2']);
				}

				if(isset($_POST['textconfig3']))
				{
					update_option('textconfig3', $_POST['textconfig3']);
				}

				if(isset($_POST['textconfig4']))
				{
					update_option('textconfig4', $_POST['textconfig4']);
				}

				if(isset($_POST['textconfig5']))
				{
					update_option('textconfig5', $_POST['textconfig5']);
				}

				if(isset($_POST['textconfig6']))
				{
					update_option('textconfig6', $_POST['textconfig6']);
				}
				
				// Put an settings updated message on the screen
			?>
				<div class="updated"><p><strong><?php _e('settings saved.', 'hpwallart' ); ?></strong></p></div>
			<?php
			}
			// Now display the settings editing screen
		
			echo '<div class="wrap">';
		
			// header
		
			echo "<h2>" . __( 'HP WallArt Plugin Settings', 'hpwallart' ) . "<p style='float:right;'>Version ".$this->version_plugin."</p></h2>";
		
			// settings form
		
			$active_tab = isset($_GET['tab']) ? $_GET['tab'] : 'general';
			if(isset($_GET['tab'])) $active_tab = $_GET['tab'];
			
			?>
            <h2 class="nav-tab-wrapper">
            <a href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=hpwallartsettings&amp;tab=general" class="nav-tab <?php if($active_tab == 'general') echo 'nav-tab-active'; ?>"><?php _e("Generic options", 'hpwallart' ); ?></a>
            <a href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=hpwallartsettings&amp;tab=stock" class="nav-tab <?php if($active_tab == 'stock') echo 'nav-tab-active'; ?>"><?php _e("Stock imagery options", 'hpwallart' ); ?></a>
            <a href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=hpwallartsettings&amp;tab=sku" class="nav-tab <?php if($active_tab == 'sku') echo 'nav-tab-active'; ?>"><?php _e("SKU options", 'hpwallart' ); ?></a>
            <a href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=hpwallartsettings&amp;tab=appearance" class="nav-tab <?php if($active_tab == 'appearance') echo 'nav-tab-active'; ?>"><?php _e("Appearance", 'hpwallart' ); ?></a>
            <a href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=hpwallartsettings&amp;tab=textconfig" class="nav-tab <?php if($active_tab == 'textconfig') echo 'nav-tab-active'; ?>"><?php _e("Text configuration", 'hpwallart' ); ?></a>
            </h2>
            
            <?php
			if($active_tab == 'general')
			{
				$hp_wallart_base_url = get_option('hp_wallart_base_url');
				$use_https = get_option('use_https');
				//$hpwallart_taxes = get_option('hpwallart_taxes');
				$set_page_principal = get_option('set_page_principal');
				$items_per_page = get_option('items_per_page');
				$number_of_scenes = get_option('number_of_scenes');
				$number_of_elements = get_option('number_of_elements');
				$active_tooltip = get_option('active_tooltip');
				$use_backgrounds = get_option('use_backgrounds');
				$use_objects = get_option('use_objects');
				$allow_users_upload = get_option('allow_users_upload');
			?>
                <form name="form1" method="post" action="">
                <input type="hidden" name="hp_submit_hidden" value="Y">
                <input type="hidden" name="active_tab" value="general">
               	<h3><?php _e("Generic Options", 'hpwallart' ); ?></h3>
                <table class="form-table">
    
                <tr>
                    <th>
                    	<label for="set_page_principal"><?php _e("Set Design as homepage", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Set Design as homepage or in a inside page", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="radio" name="set_page_principal" id="set_page_principal" value="1" <?php if($set_page_principal == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Set Design as homepage", 'hpwallart' ); ?></span>
    
                        <input type="radio" name="set_page_principal" id="set_page_principal" value="2" <?php echo $set_page_principal == ''? 'checked="checked"' : ($set_page_principal == 2? 'checked="checked"' : ''); ?> >
                        <span class="description"><?php _e("Unset Design as homepage", 'hpwallart' ); ?></span>
                    </td>
                </tr>

                <tr>
                    <th>
                    	<label for="use_backgrounds"><?php _e("Use backgrounds", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Activate the Step 2 width Backgrounds", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="checkbox" name="use_backgrounds" id="use_backgrounds" value="1" <?php if(!isset($use_backgrounds) || $use_backgrounds == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Check if you are using backgrounds", 'hpwallart' ); ?></span>
                    </td>
                </tr>

                <tr>
                    <th>
                    	<label for="use_objects"><?php _e("Use objects", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Activate the Step 3 with Objects", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="checkbox" name="use_objects" id="use_objects" value="1" <?php if(!isset($use_objects) || $use_objects == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Check if you are using objects", 'hpwallart' ); ?></span>
                    </td>
                </tr>

                <tr>
                    <th>
                    	<label for="allow_users_upload"><?php _e("Allow user to upload their own images", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Allow user to upload their own images", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="checkbox" name="allow_users_upload" id="allow_users_upload" value="1" <?php if(!isset($allow_users_upload) || $allow_users_upload == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Check if you allow user to upload their own images", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>

                <hr />
                
                <table class="form-table">
                <tr>
                    <th>
                    	<label for="items_per_page"><?php _e("Images per page", 'hpwallart' ); ?> </label>
                        <img title="<?php _e("Set the number of images per page in the backgrounds and objects pages", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="number" name="items_per_page" value="<?php echo $items_per_page? $items_per_page : 8; ?>" size="2">
                        <span class="description"><?php _e("Set the number of images per page in the backgrounds and objects pages", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                
                <tr>
                    <th>
                    	<label for="number_of_scenes"><?php _e("Backgrounds on the sidebar", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Set the maximum number of backgrounds on the sidebar", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="number" name="number_of_scenes" value="<?php echo $number_of_scenes? $number_of_scenes : 4; ?>" size="2">
                        <span class="description"><?php _e("Set the maximum number of backgrounds on the sidebar", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                
                <tr>
                    <th>
                    	<label for="number_of_elements"><?php _e("Objects on the sidebar", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Set the maximum number of objects on the sidebar", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="number" name="number_of_elements" value="<?php echo $number_of_elements ? $number_of_elements : 4; ?>" size="2">
                        <span class="description"><?php _e("Set the maximum number of objects on the sidebar", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                
                <tr>
                    <th>
                    	<label for="active_tooltip"><?php _e("Active tooltip", 'hpwallart' ); ?></label>
                        <img title="<?php _e("Activate the tooltips over the images", 'hpwallart' ); ?>" class="tiptip" src="<?php echo plugins_url( 'images/help.png', __FILE__ ); ?>" />
                    </th>
                    <td>
                        <input type="checkbox" name="active_tooltip" value="1" <?php if($active_tooltip == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Activate the tooltips over the images", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>
                <hr />
                
                <p class="submit">
                <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
                </p>
                
                </form>
			<?php
			}
			?>
            <?php
			if($active_tab == 'sku')
			{
				//LOAD DATA
				if(count($data['applications']))
				{
					foreach($data['applications'] as $k => $v)
					{
						${"use_{$v['sku']}"} = get_option('use_'.$v['sku']);
						${"{$v['sku']}_backgrounds"} = get_option($v['sku'].'_backgrounds');
						${"{$v['sku']}_objects"} = get_option($v['sku'].'_objects');
					}
				}

				if(count($data['application_groups']))
				{
					foreach($data['application_groups'] as $k2 => $v2)
					{
						foreach($v2['applications'] as $k => $v)
						{
							//$v['sku'] = strtolower(preg_replace('/\s+/', '', $v['name']));
							
							${"use_{$v['sku']}"} = get_option('use_'.$v['sku']);
							${"{$v['sku']}_backgrounds"} = get_option($v['sku'].'_backgrounds');
							${"{$v['sku']}_objects"} = get_option($v['sku'].'_objects');
						}
					}
				}				
			?>
                <form name="form2" method="post" action="">
                <input type="hidden" name="hp_submit_hidden" value="Y">
                <input type="hidden" name="active_tab" value="sku">
               	<h3><?php _e("SKU Options", 'hpwallart' ); ?></h3>
                <table class="form-table">
                <tr>
                	<th><?php _e("SKU", 'hpwallart' ); ?></th>
                	<th><?php _e("Select/Deselect", 'hpwallart' ); ?></th>
                	<th><?php _e("Backgrounds imagery", 'hpwallart' ); ?></th>
                	<th><?php _e("Objects imagery", 'hpwallart' ); ?></th>
                </tr>
                
                <!--2016-09-14 NEW update to show signage and others applications-->
                <?php
				if(count($data['applications']))
				{
					foreach($data['applications'] as $k => $v)
					{
						if($v['status'] == '1')
						{
				?>
                         <tr>
                            <th><label for="use_<?php echo $v['sku']; ?>"><?php _e("Use ".$v['name'], 'hpwallart' ); ?></label></th>
                            <td>
                                <input <?php if($v['status'] != 1) echo 'disabled="disabled"'; ?> type="checkbox" name="use_<?php echo $v['sku']; ?>" id="use_<?php echo $v['sku']; ?>" value="1" <?php if(${"use_{$v['sku']}"} == 1) echo 'checked="checked"'; ?> >
                                <span class="description"><?php _e("Check if you are using ".$v['name'], 'hpwallart' ); ?></span>
                            </td>
                            <td>
                            <?php
                            if($v['backgrounds'] == '1')
                            {
                            ?>
                                <select <?php if($v['status'] != 1) echo 'disabled="disabled"'; ?> name="<?php echo $v['sku']; ?>_backgrounds" id="<?php echo $v['sku']; ?>_backgrounds">
                                    <option value=""><?php _e("Select an option", 'hpwallart' ); ?></option>
                                <?php if(false){ ?>
                                    <option <?php if($v['content'][0]['fotolia'] != 1) echo 'disabled="disabled"'; ?> value="1" <?php if(${"{$v['sku']}_backgrounds"} == 1) echo 'selected="selected"'; ?> ><?php _e("Fotolia", 'hpwallart' ); ?></option>
                                    <option value="2" <?php if(${"{$v['sku']}_backgrounds"} == 2) echo 'selected="selected"'; ?> ><?php _e("Big Stock Photo", 'hpwallart' ); ?></option>
                                <?php }?>
                                    <option <?php if($v['content'][0]['pattern_design'] != 1) echo 'disabled="disabled"'; ?> value="3" <?php if(${"{$v['sku']}_backgrounds"} == 3) echo 'selected="selected"'; ?> ><?php _e("Pattern Design", 'hpwallart' ); ?></option>                                
                                    <option value="4" <?php if(${"{$v['sku']}_backgrounds"} == 4) echo 'selected="selected"'; ?> ><?php _e("Media gallery", 'hpwallart' ); ?></option>
                                <?php if(false){ ?>
                                    <!--<option value="5" <?php if(${"{$v['sku']}_backgrounds"} == 5) echo 'selected="selected"'; ?> ><?php _e("User Dropbox", 'hpwallart' ); ?></option>
                                                <option value="6" <?php if(${"{$v['sku']}_backgrounds"} == 6) echo 'selected="selected"'; ?> ><?php _e("Google Drive", 'hpwallart' ); ?></option>
                                    <option <?php if($v['content'][0]['dropbox'] != 1) echo 'disabled="disabled"'; ?> value="7" <?php if(${"{$v['sku']}_backgrounds"} == 7) echo 'selected="selected"'; ?> ><?php _e("Dropbox", 'hpwallart' ); ?></option>
                                     --><option <?php if($v['content'][0]['instagram'] != 1) echo 'disabled="disabled"'; ?> value="8" <?php if(${"{$v['sku']}_backgrounds"} == 8) echo 'selected="selected"'; ?> ><?php _e("Instagram", 'hpwallart' ); ?></option>
                                <?php } ?>
                               </select>
                            <?php
                            }
                            else
                            {
                                _e("n/a", 'hpwallart' );
                            }
                            ?>
                            </td>
        
                            <td>
                                <select <?php if($v['status'] != 1) echo 'disabled="disabled"'; ?> name="<?php echo $v['sku']; ?>_objects" id="<?php echo $v['sku']; ?>_objects">
                                    <option value=""><?php _e("Select an option", 'hpwallart' ); ?></option>
                                <?php if(false){ ?>
                                    <option <?php if($v['content'][0]['fotolia'] != 1) echo 'disabled="disabled"'; ?> value="1" <?php if(${"{$v['sku']}_objects"} == 1) echo 'selected="selected"'; ?> ><?php _e("Fotolia", 'hpwallart' ); ?></option>
                                    <option value="2" <?php if(${"{$v['sku']}_objects"} == 2) echo 'selected="selected"'; ?> ><?php _e("Big Stock Photo", 'hpwallart' ); ?></option>
                                <?php } ?>
                                    <option value="4" <?php if(${"{$v['sku']}_objects"} == 4) echo 'selected="selected"'; ?> ><?php _e("Media gallery", 'hpwallart' ); ?></option>
                                <?php if(false){ ?>
                                    <!--<option value="5" <?php if(${"{$v['sku']}_objects"} == 5) echo 'selected="selected"'; ?> ><?php _e("User Dropbox", 'hpwallart' ); ?></option>
                                    <option value="6" <?php if(${"{$v['sku']}_objects"} == 6) echo 'selected="selected"'; ?> ><?php _e("Google Drive", 'hpwallart' ); ?></option>
                                    <option <?php if($v['content'][0]['dropbox'] != 1) echo 'disabled="disabled"'; ?> value="7" <?php if(${"{$v['sku']}_objects"} == 7) echo 'selected="selected"'; ?> ><?php _e("Dropbox", 'hpwallart' ); ?></option>
                                    --><option <?php if($v['content'][0]['instagram'] != 1) echo 'disabled="disabled"'; ?> value="8" <?php if(${"{$v['sku']}_objects"} == 8) echo 'selected="selected"'; ?> ><?php _e("Instagram", 'hpwallart' ); ?></option>
                                <?php } ?>
                               </select>
                            </td>
                            </tr>
				<?php
						}
					}
				}

				//applications groups
				if(count($data['application_groups']))
				{
					foreach($data['application_groups'] as $k2 => $v2)
					{
						foreach($v2['applications'] as $k => $v)
						{
							if($v['status'] == '1')
							{
						//$v['sku'] = strtolower(preg_replace('/\s+/', '', $v['name']));
				?>
                            <tr>
                                <th><label for="use_<?php echo $v['sku']; ?>"><?php _e("Use ".$v['name'], 'hpwallart' ); ?></label></th>
                                <td>
                                    <input type="checkbox" name="use_<?php echo $v['sku']; ?>" id="use_<?php echo $v['sku']; ?>" value="1" <?php if(${"use_{$v['sku']}"} == 1) echo 'checked="checked"'; ?> >
                                    <span class="description"><?php _e("Check if you are using ".$v['name'], 'hpwallart' ); ?></span>
                                </td>
                                <td>
                                <?php
                                if($v['backgrounds'] == '1')
                                {
                                ?>
                                    <select name="<?php echo $v['sku']; ?>_backgrounds" id="<?php echo $v['sku']; ?>_backgrounds">
                                        <option value=""><?php _e("Select an option", 'hpwallart' ); ?></option>
                                    <?php if(false){ ?>
                                        <option <?php if($v['content'][0]['fotolia'] != 1) echo 'disabled="disabled"'; ?> value="1" <?php if(${"{$v['sku']}_backgrounds"} == 1) echo 'selected="selected"'; ?> ><?php _e("Fotolia", 'hpwallart' ); ?></option>
                                        <option value="2" <?php if(${"{$v['sku']}_backgrounds"} == 2) echo 'selected="selected"'; ?> ><?php _e("Big Stock Photo", 'hpwallart' ); ?></option>
                                    <?php } ?>
                                        <option <?php if($v['content'][0]['pattern_design'] != 1) echo 'disabled="disabled"'; ?> value="3" <?php if(${"{$v['sku']}_backgrounds"} == 3) echo 'selected="selected"'; ?> ><?php _e("Pattern Design", 'hpwallart' ); ?></option>
                                        <option value="4" <?php if(${"{$v['sku']}_backgrounds"} == 4) echo 'selected="selected"'; ?> ><?php _e("Media gallery", 'hpwallart' ); ?></option>
                                    <?php if(false){ ?>
                                        <!--<option value="5" <?php if(${"{$v['sku']}_backgrounds"} == 5) echo 'selected="selected"'; ?> ><?php _e("User Dropbox", 'hpwallart' ); ?></option>
                                        <option value="6" <?php if(${"{$v['sku']}_backgrounds"} == 6) echo 'selected="selected"'; ?> ><?php _e("Google Drive", 'hpwallart' ); ?></option>
                                        <option <?php if($v['content'][0]['dropbox'] != 1) echo 'disabled="disabled"'; ?> value="7" <?php if(${"{$v['sku']}_backgrounds"} == 7) echo 'selected="selected"'; ?> ><?php _e("Dropbox", 'hpwallart' ); ?></option>
                                        <option <?php if($v['content'][0]['instagram'] != 1) echo 'disabled="disabled"'; ?> value="8" <?php if(${"{$v['sku']}_backgrounds"} == 8) echo 'selected="selected"'; ?> ><?php _e("Instagram", 'hpwallart' ); ?></option>-->
                                    <?php } ?>
                                    </select>
                                <?php
                                }
                                else
                                {
                                    _e("n/a", 'hpwallart' );
                                }
                                ?>
                                </td>
            
                                <td>
                                    <select name="<?php echo $v['sku']; ?>_objects" id="<?php echo $v['sku']; ?>_objects">
                                        <option value=""><?php _e("Select an option", 'hpwallart' ); ?></option>
                                    <?php if(false){ ?>
                                        <option <?php if($v['content'][0]['fotolia'] != 1) echo 'disabled="disabled"'; ?> value="1" <?php if(${"{$v['sku']}_objects"} == 1) echo 'selected="selected"'; ?> ><?php _e("Fotolia", 'hpwallart' ); ?></option>
                                        <option value="2" <?php if(${"{$v['sku']}_objects"} == 2) echo 'selected="selected"'; ?> ><?php _e("Big Stock Photo", 'hpwallart' ); ?></option>
                                    <?php } ?>
                                        <option value="4" <?php if(${"{$v['sku']}_objects"} == 4) echo 'selected="selected"'; ?> ><?php _e("Media gallery", 'hpwallart' ); ?></option>
                                    <?php if(false){ ?>
                                        <!--<option value="5" <?php if(${"{$v['sku']}_objects"} == 5) echo 'selected="selected"'; ?> ><?php _e("User Dropbox", 'hpwallart' ); ?></option>
                                        <option value="6" <?php if(${"{$v['sku']}_objects"} == 6) echo 'selected="selected"'; ?> ><?php _e("Google Drive", 'hpwallart' ); ?></option>
                                        <option <?php if($v['content'][0]['dropbox'] != 1) echo 'disabled="disabled"'; ?> value="7" <?php if(${"{$v['sku']}_objects"} == 7) echo 'selected="selected"'; ?> ><?php _e("Dropbox", 'hpwallart' ); ?></option>
                                        <option <?php if($v['content'][0]['instagram'] != 1) echo 'disabled="disabled"'; ?> value="8" <?php if(${"{$v['sku']}_objects"} == 8) echo 'selected="selected"'; ?> ><?php _e("Instagram", 'hpwallart' ); ?></option>-->
                                    <?php } ?>
                                    </select>
                                </td>
                            </tr>
				<?php
							}
						}
					}
				}
				?>
                </table>
                <hr />
                
                <p class="submit">
                <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
                </p>
                
                </form>
 			<?php
			}
			//hpwallart
			if($active_tab == 'stock')
			{
				//$select_image_provider = get_option('select_image_provider');
				$fotolia_api_key = get_option('fotolia_api_key');
				$instagram_access_token = get_option('instagram_access_token');
				$big_stock_photo_account_id = get_option('big_stock_photo_account_id');
				$big_stock_photo_secret_key = get_option('big_stock_photo_secret_key');
				$pattern_design_api_key = get_option('pattern_design_api_key');
				$pattern_design_hmac_key = get_option('pattern_design_hmac_key');
				$dropbox_api_key = get_option('dropbox_api_key');
				$dropbox_api_secret = get_option('dropbox_api_secret');
				$gd_scenes_url = get_option('gd_scenes_url');
				$gd_objects_url = get_option('gd_objects_url');
				$gd_max_depth = get_option('gd_max_depth');
				$dropbox_scenes_url = get_option('dropbox_scenes_url');
				$dropbox_objects_url = get_option('dropbox_objects_url');

				$dropbox_token = get_option('dropbox_token');
			?>
                <form name="form3" method="post" action="">
                <input type="hidden" name="hp_submit_hidden" value="Y">
                <input type="hidden" name="active_tab" value="stock">

                <h3><?php _e("Stock Imagery Options", 'hpwallart' ); ?></h3>
               <?php if(false){ ?>
				<h3 style="float:left;"><?php _e("Fotolia settings", 'hpwallart' ); ?></h3>              
                <img src="https://s.ftcdn.net/r/v2013/a83296d613f28d5b352d0ea0e6ecb4c8cd142935/pics/all/hab/fotolia-logo.png" style="float:right; margin:1em 0 0 2em; height:30px;" />            
                <table class="form-table" id="fotolia" style="background:white;">
                <tr>
                    <th style=" padding:1em;"><label for="fotolia_api_key"><?php _e("Fotolia API Key", 'hpwallart' ); ?></label></th>
                    <td>
                        <input type="text" name="fotolia_api_key" value="<?php echo $fotolia_api_key; ?>" size="40">
                        <span class="description"><?php _e("Enter the API key provided by Fotolia", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>
               
				<h3 style="float:left;"><?php _e("Instagram settings", 'hpwallart' ); ?></h3>
                <img src="http://diylogodesigns.com/blog/wp-content/uploads/2016/05/instagram-Logo-PNG-Transparent-Background-download.png" style="float:right; margin:1em 0 0 2em; height:30px;" />
                <table class="form-table" id="fotolia" style="background:white;">
                <tr>
                    <th style=" padding:1em;"><label for="instagram_access_token"><?php _e("Instagram access toekn", 'hpwallart' ); ?></label></th>
                    <td>
                        <input type="text" name="instagram_access_token" value="<?php echo $instagram_access_token; ?>" size="60">
                        <span class="description"><?php _e("Enter the Instagram access token", 'hpwallart' ); ?></span>
                        <span><a target="_blank" href="http://wix.hpwallart.com/instagram">To get an access token click here</a></span>
                    </td>
                </tr>
                </table>
                
				<h3 style="float:left;"><?php _e("Big Stock Photo settings", 'hpwallart' ); ?></h3>  
                <img src="http://static.bigstockphoto.com/images/big.jpg" style="float:right; margin:1em 0 0 2em; height:30px;" />
                <table class="form-table" id="bigstockphoto" style="background:white;">
                <tr>
                    <th style=" padding:1em;"><label for="big_stock_photo_account_id"><?php _e("Big Stock Photo Account Id", 'hpwallart' ); ?></label></th>
                    <td>
                        <input type="text" name="big_stock_photo_account_id" value="<?php echo $big_stock_photo_account_id; ?>" size="10">
                        <span class="description"><?php _e("Enter the Account Id provided by Big Stock Photo", 'hpwallart' ); ?></span>
                    </td>                    
                </tr>
                <tr>
                    <th style=" padding:1em;"><label for="big_stock_photo_secret_key"><?php _e("Big Stock Photo Secret Key", 'hpwallart' ); ?></label></th>
                    <td>
                        <input type="text" name="big_stock_photo_secret_key" value="<?php echo $big_stock_photo_secret_key; ?>" size="50">
                        <span class="description"><?php _e("Enter the Secret Key provided by Big Stock Photo", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>
                <?php } ?>
				<h3 style="float:left;"><?php _e("Pattern Design settings", 'hpwallart' ); ?></h3>              
                <img src="http://cdn.patterndesigns.com/images/website/logo.png" style="float:right; margin:1em 0 0 2em; height:30px;" />
                <table class="form-table" id="patterndesign" style="background:white;">
                <tr>
                    <th style=" padding:1em;"><label for="pattern_design_api_key"><?php _e("Pattern Design API key", 'hpwallart' ); ?> </label></th>
                    <td>
                        <input type="text" name="pattern_design_api_key" value="<?php echo $pattern_design_api_key; ?>" size="30">
                        <span class="description"><?php _e("Enter the API key provided by Pattern Design", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                <tr>
                    <th style=" padding:1em;"><label for="pattern_design_hmac_key"><?php _e("Pattern Design HMAC Key", 'hpwallart' ); ?></label></th>
                    <td>
                        <input type="text" name="pattern_design_hmac_key" value="<?php echo $pattern_design_hmac_key; ?>" size="75">
                        <span class="description"><?php _e("Enter the HMAC Key provided by Pattern Design", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>
    
				<h3 style="float:left;"><?php _e("Media library", 'hpwallart' ); ?></h3>              
                <img src="https://s.w.org/about/images/logos/wordpress-logo-hoz-rgb.png" style="float:right; margin:1em 0 0 2em; height:30px;" />
                <table class="form-table" id="medialibrary" style="background:white;">
                <tr>
                    <td colspan="2">
                        <p class="description"><?php _e('You will use your own images and files hosted on Wordpress Media library.', 'hpwallart' ); ?></p>
                    </td>
                </tr>
                </table>
                
                <hr />
                
                <p class="submit">
                <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
                </p>
                
                </form>
 			<?php
			}
			//Appearance
			if($active_tab == 'appearance')
			{
				$appearance = unserialize(get_option('appearance'));
			?>
                <form name="form4" method="post" action="">
                <input type="hidden" name="active_tab" value="appearance">
				<h3><?php _e("Appearance", 'hpwallart' ); ?></h3>
                 
                <h3 style="float:left;"><?php _e("Navigation bar", 'hpwallart' ); ?></h3>
                <table class="form-table" style="background:white; width:50%;">
                <tr>
                	<th style="padding:1em;" colspan="4"><img src="<?php echo plugins_url('hpwallart/images/navigation.png'); ?>" style="margin:0em;" /></th>
                </tr>
               
                <tr>
                    <th style="padding:1em;" width="40%"><label for="appearance[nav_bar_bg]"><?php _e("Navigation bar background", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[nav_bar_bg]" name="appearance[nav_bar_bg]" value="<?php echo $appearance['nav_bar_bg']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" width="40%"><label for="appearance[nav_bar_bg_fc]"><?php _e("Navigation bar background font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[nav_bar_bg_fc]" name="appearance[nav_bar_bg_fc]" value="<?php echo $appearance['nav_bar_bg_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>

                <tr>
                    <th style="padding:1em;"><label for="appearance[nav_bar_bg_selected]"><?php _e("Navigation bar background selected", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;">
                        <div class="color-picker"><input type="text" id="appearance[nav_bar_bg_selected]" name="appearance[nav_bar_bg_selected]" value="<?php echo $appearance['nav_bar_bg_selected']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" nowrap="nowrap"><label for="appearance[nav_bar_bg_selected_fc]"><?php _e("Navigation bar background selected font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;">
                        <div class="color-picker"><input type="text" id="appearance[nav_bar_bg_selected_fc]" name="appearance[nav_bar_bg_selected_fc]" value="<?php echo $appearance['nav_bar_bg_selected_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>

                <tr>
                    <th style="padding:1em;"><label for="appearance[nav_bar_bg_selected_ok]"><?php _e("Navigation bar background passed", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;">
                        <div class="color-picker"><input type="text" id="appearance[nav_bar_bg_selected_ok]" name="appearance[nav_bar_bg_selected_ok]" value="<?php echo $appearance['nav_bar_bg_selected_ok']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" nowrap="nowrap"><label for="appearance[nav_bar_bg_selected_ok_fc]"><?php _e("Navigation bar background passed font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;">
                        <div class="color-picker"><input type="text" id="appearance[nav_bar_bg_selected_ok_fc]" name="appearance[nav_bar_bg_selected_ok_fc]" value="<?php echo $appearance['nav_bar_bg_selected_ok_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>
                
                <tr>
                    <th style="padding:1em;"><label for="appearance[nav_bar_border_radius]"><?php _e("Navigation bar border radius", 'hpwallart' ); ?></label></th>
                    <td colspan="3" style="padding:1em;">
                        <input type="checkbox" name="appearance[nav_bar_border_radius]" id="appearance[nav_bar_border_radius]" value="1" <?php if($appearance['nav_bar_border_radius'] == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Check for border radius ", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>

                <hr />

				<h3 style="float:left;"><?php _e("Buttons", 'hpwallart' ); ?></h3>
                <table class="form-table" style="background:white; width:50%;">
                <tr>
                	<th style="padding:1em;" width="100%" colspan="4"><img src="<?php echo plugins_url('hpwallart/images/buttons.png'); ?>" style="margin:0em;" /></th>
                </tr>
               
                <tr>
                    <th style="padding:1em;" width="40%"><label for="appearance[buttons_bg]"><?php _e("Buttons background", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[buttons_bg]" name="appearance[buttons_bg]" value="<?php echo $appearance['buttons_bg']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" width="40%"><label for="appearance[buttons_bg_fc]"><?php _e("Buttons font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[buttons_bg_fc]" name="appearance[buttons_bg_fc]" value="<?php echo $appearance['buttons_bg_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>

                <tr>
                    <th style="padding:1em;" width="40%"><label for="appearance[buttons_bg_help]"><?php _e("Help button background", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[buttons_bg_help]" name="appearance[buttons_bg_help]" value="<?php echo $appearance['buttons_bg_help']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" width="40%"><label for="appearance[buttons_bg_help_fc]"><?php _e("Help button font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[buttons_bg_help_fc]" name="appearance[buttons_bg_help_fc]" value="<?php echo $appearance['buttons_bg_help_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>

                <tr>
                    <th style="padding:1em;" width="40%"><label for="appearance[buttons_bg_designer]"><?php _e("Go to designer button background", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[buttons_bg_designer]" name="appearance[buttons_bg_designer]" value="<?php echo $appearance['buttons_bg_designer']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" width="40%"><label for="appearance[buttons_bg_designer_fc]"><?php _e("Go to designer button font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[buttons_bg_designer_fc]" name="appearance[buttons_bg_designer_fc]" value="<?php echo $appearance['buttons_bg_designer_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
               	</tr>
                
                <tr>
                    <th style="padding:1em;"><label for="appearance[buttons_border_radius]"><?php _e("Buttons border radius", 'hpwallart' ); ?></label></th>
                    <td colspan="3" style="padding:1em;">
                        <input type="checkbox" name="appearance[buttons_border_radius]" id="appearance[buttons_border_radius]" value="1" <?php if($appearance['buttons_border_radius'] == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Check for border radius ", 'hpwallart' ); ?></span>
                    </td>
                </tr>
                </table>

                <hr />

				<h3 style="float:left;"><?php _e("Images selector", 'hpwallart' ); ?></h3>
                <table class="form-table" style="background:white; width:50%;">
                <tr>
                	<th style="padding:1em;" width="100%" colspan="4"><img src="<?php echo plugins_url('hpwallart/images/images_sel.png'); ?>" style="margin:0em;" /></th>
                </tr>
               
                <tr>
                    <th style="padding:1em;" width="40%"><label for="appearance[sel_butt_bg]"><?php _e("Select button background", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[sel_butt_bg]" name="appearance[sel_butt_bg]" value="<?php echo $appearance['sel_butt_bg']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" width="40%"><label for="appearance[sel_butt_bg_fc]"><?php _e("Select button font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[sel_butt_bg_fc]" name="appearance[sel_butt_bg_fc]" value="<?php echo $appearance['sel_butt_bg_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>
               
                <tr>
                    <th style="padding:1em;" width="40%"><label for="appearance[selted_butt_bg]"><?php _e("Selected button background", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[selted_butt_bg]" name="appearance[selted_butt_bg]" value="<?php echo $appearance['selted_butt_bg']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                    <th style="padding:1em;" width="40%"><label for="appearance[selted_butt_bg_fc]"><?php _e("Selected button font color", 'hpwallart' ); ?></label></th>
                    <td style="padding:1em;" width="10%">
                        <div class="color-picker"><input type="text" id="appearance[selted_butt_bg_fc]" name="appearance[selted_butt_bg_fc]" value="<?php echo $appearance['selted_butt_bg_fc']; ?>" data-default-color="#444" class="my-input-class" /></div>
                    </td>
                </tr>
                
                <tr>
                    <th style="padding:1em;"><label for="appearance[selted_border_radius]"><?php _e("Image select buttons border radius", 'hpwallart' ); ?></label></th>
                    <td colspan="3" style="padding:1em;">
                        <input type="checkbox" name="appearance[selted_border_radius]" id="appearance[selted_border_radius]" value="1" <?php if($appearance['selted_border_radius'] == 1) echo 'checked="checked"'; ?> >
                        <span class="description"><?php _e("Check for border radius ", 'hpwallart' ); ?></span>
                    </td>
                </tr>
				</table>
                
                <p class="submit">
                <input type="hidden" name="reset_styles" value="0">
                <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
                <input type="button" name="Submit" class="button-secondary" onclick="this.form.reset_styles.value='1'; this.form.submit();" value="<?php esc_attr_e('Reset all styles') ?>" />
                </p>
                </form>
			<?php
			}
			if($active_tab == 'textconfig')
			{
				$textconfig1 = stripslashes(get_option('textconfig1'));
				$textconfig2 = stripslashes(get_option('textconfig2'));
				$textconfig3 = stripslashes(get_option('textconfig3'));
				$textconfig4 = stripslashes(get_option('textconfig4'));
				$textconfig5 = stripslashes(get_option('textconfig5'));
				$textconfig6 = stripslashes(get_option('textconfig6'));
		    ?>
				<form name="form5" method="post" action="">
	                <input type="hidden" name="hp_submit_hidden" value="Y">
	                <input type="hidden" name="active_tab" value="textconfig">

	                <h3><?php _e("Text Customisation", 'hpwallart' ); ?></h3>
	               
					<table class="form-table" id="fotolia" style="background:white;">
					<tr>
	                    <th style=" padding:1em;"><label for="">Original Text</label></th>
	                    <th style=" padding:1em;"><label for="">Text to be Replaced</label></th>
	                </tr>
	                <tr>
	                    <th style=" padding:1em;"><label for=""><?php echo "Formats and measures"; ?></label></th>
	                    <td>
	                        <input type="text" name="textconfig1" value="<?php echo $textconfig1; ?>" size="40">
	                    </td>
	                </tr>
	                <tr>
	                    <th style=" padding:1em;"><label for=""><?php echo 'Select a format, adjust the dimensions and click on "calculate" for an estimated price. Then click on "next" to select image files.'; ?></label></th>
	                    <td>
	                    	<textarea type="text" name="textconfig2" rows="10" cols="75"><?php echo $textconfig2; ?></textarea>
	                    </td>
	                </tr>
	                <tr>
	                    <th style=" padding:1em;"><label for=""><?php echo 'Background images serve as the basis of design or design itself.'; ?></label></th>
	                    <td>
	                    	<textarea type="text" name="textconfig3" rows="10" cols="75"><?php echo $textconfig3; ?></textarea>
	                    </td>
	                </tr>
	                <tr>
	                    <th style=" padding:1em;"><label for=""><?php echo 'Search and select the images you want to incorporate into the project as background images.'; ?></label></th>
	                    <td>
	                    	<textarea type="text" name="textconfig4" rows="10" cols="75"><?php echo $textconfig4; ?></textarea>
	                    </td>
	                </tr>
	                <tr>
	                    <th style=" padding:1em;"><label for=""><?php echo 'The images of objects, can be superimposed on a background creating multilayered compositions.'; ?></label></th>
	                    <td>
	                    	<textarea type="text" name="textconfig5" rows="10" cols="75"><?php echo $textconfig5; ?></textarea>
	                    </td>
	                </tr>
	                <tr>
	                    <th style=" padding:1em;"><label for=""><?php echo 'Search and select the images you want to incorporate into the project as images of objects.'; ?></label></th>
	                    <td>
	                    	<textarea type="text" name="textconfig6" rows="10" cols="75"><?php echo $textconfig6; ?></textarea>
	                    </td>
	                </tr>
	                </table>
	                <p class="submit">
	                <input type="hidden" name="reset_styles" value="0">
	                <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
	                </p>
                </form>
			<?php
		    }
			?>
		</div>
		<?php
		}
		// wa_settings_page() displays the page content for the www.hpwallart.com settings 
		public function wa_settings_page()
		{
			global $wpdb;
			global $woocommerce;
			
			//must check that the user has the required capability 
			if (!current_user_can('manage_options'))
			{
			  wp_die( __('You do not have sufficient permissions to access this page.') );
			}
			
			
			// Read in existing option value from database
			$wallart_user = get_option('wallart_user');
			$wallart_password = get_option('wallart_password');
			$hp_wallart_base_url = get_option('hp_wallart_base_url');
			$wallart_key = get_option('wallart_key');
		
			// See if the user has posted us some information
			// If they did, this hidden field will be set to 'Y'
			if( isset($_POST['hp_submit_hidden']) && $_POST['hp_submit_hidden'] == 'Y' )
			{
				$wallart_user = $_POST['wallart_user'];
				$wallart_password = $_POST['wallart_password'];
				$hp_wallart_base_url = $_POST['hp_wallart_base_url'];
				$wallart_key = $_POST['wallart_key'];

				// Save the posted value in the database
				update_option( 'wallart_user', $wallart_user );
				update_option( 'wallart_password', $wallart_password );
				update_option( 'hp_wallart_base_url', $hp_wallart_base_url );
				update_option( 'wallart_key', $wallart_key );
				
				$this->createItem();
		
				// Put an settings updated message on the screen
			?>
				<div class="updated"><p><strong><?php _e('settings saved.', 'hpwallart' ); ?></strong></p></div>
			<?php
			}
	
			// Now display the settings editing screen
		
			echo '<div class="wrap">';
		
			// header
		
			echo "<h2>" . __( 'WallArt Settings', 'hpwallart' ) . "</h2>";
		
			// settings form
			?>
			<form name="form2" method="post" action="" autocomplete="off">
			<input type="hidden" name="hp_submit_hidden" value="Y">
			
            <h3><?php _e("www.hpwallart.com data", 'hpwallart' ); ?></h3>
            <div class="description"><?php echo _e("Introducing the API Key or User Credentials for your www.hpwallart.com account, you can check if the installation is well done or if you have to correct some parameter, either in this plugin, or in your www.hpwallart.com account.", 'hpwallart'); ?></div>
            <table class="form-table">
            <p>Select any one of the option to get a HP data</p>
            <input type="radio" name="answer" checked="checked" value="preset"/> API Key
            <input type="radio" name="answer"  value="custom" "/> User Credentials
			<tr id="user">
				<th><label for="wallart_user"><?php _e("WallArt user", 'hpwallart' ); ?></label></th>
				<td>
                	<input type="text" name="wallart_user" id="wallart_user" value="<?php echo $wallart_user; ?>" size="31" readonly onfocus="this.removeAttribute('readonly');" style="background:#fff;">
					<span class="description"><?php _e("Enter the user (email) for www.hpwallart.com", 'hpwallart' ); ?></span>
            	</td>
            </tr>

			<tr id="pass">
				<th><label for="wallart_password"><?php _e("WallArt password", 'hpwallart' ); ?></label></th>
				<td>
                	<input type="password" name="wallart_password" id="wallart_password" value="<?php echo $wallart_password; ?>" size="31" readonly onfocus="this.removeAttribute('readonly');" style="background:#fff;">
					<span class="description"><?php _e("Enter the password for www.hpwallart.com", 'hpwallart' ); ?></span>
            	</td>
            </tr>

            <tr id="apikey">
				<th><label for="wallart_key"><?php _e("WallArt API Key", 'hpwallart' ); ?></label></th>
				<td>
                	<input type="text" name="wallart_key" id="wallart_key" value="<?php echo $wallart_key; ?>" size="31" readonly onfocus="this.removeAttribute('readonly');" style="background:#fff;">
					<span class="description"><?php _e("Enter the key provided by HP WallArt", 'hpwallart' ); ?></span>
            	</td>
            </tr>

            <tr>
                <th><label for="hp_wallart_base_url"><?php _e("HP WallArt URL Identifier", 'hpwallart' ); ?></label></th>
                <td>
                    <input type="text" name="hp_wallart_base_url" id="hp_wallart_base_url" value="<?php echo $hp_wallart_base_url; ?>" size="31" readonly onfocus="this.removeAttribute('readonly');" style="background:#fff;">
                    <span class="description"><?php _e("Enter the identifier provided by HP WallArt", 'hpwallart' ); ?></span>
                </td>
            </tr>
            </table>
           
            <hr />
			
			<p class="submit">
			<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes and Check Data') ?>" />
			<input type="submit" name="Submit" class="button-secondary" value="<?php esc_attr_e('Update Data From HP WallArt') ?>" />
			</p>
			
			</form>
            <hr />

            <h3><?php _e("Data check", 'hpwallart' ); ?></h3>
			<?php
			//read data from ddbb
			$data = unserialize(get_option('wallart_data'));
						
			//update data from hpwallart
			if(isset($_POST['hp_submit_hidden']) && $_POST['hp_submit_hidden'] == 'Y')
			{
				$hp_wallart_base_url = get_option('hp_wallart_base_url');
				$host = 'https://hpwallart.com/'.$hp_wallart_base_url.'/settings_info';
				$process = curl_init($host);

				if($wallart_key){
					curl_setopt($process, CURLOPT_HTTPHEADER, array('X-API-KEY:'.$wallart_key));
			    }
				elseif($wallart_user && $wallart_password){
					curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type:application/json', "Authorization: Basic " . base64_encode($wallart_user . ":" . $wallart_password)));
			    }
			    else{
			    	echo "<div class='autherror'>Please Enter User Creaditials or API Key</div>";
			    }
;
				curl_setopt($process, CURLOPT_TIMEOUT, 300);
				//curl_setopt($process, CURLOPT_HTTPGET, TRUE);
				curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
				curl_setopt($process, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
				$return = curl_exec($process);
				curl_close($process);
		
				if($_GET['show_me'] == 'yes')
				{
					echo '<pre>'; print_r(json_decode($return, true)); echo '</pre>';
				}
							
				$data = json_decode($return, true);
				
				//save all the array in a variable
				update_option( 'wallart_data', serialize($data) );
				
				//echo '<pre>'; print_r($data); echo '</pre>';
				
				//UPDATE VAT AND CURRENCY
				if($data['customization']['price']['currency_symbol'] != '')
				{
					update_option('woocommerce_currency', $data['customization']['price']['currency_symbol']);
					//update_option('woocommerce_currency_symbols', $data['customization']['price']['currency_symbol']);
					update_option('hpwallart_currency', $data['customization']['price']['currency_symbol']);
				}

				if($data['customization']['price']['vat'] != '')
				{
					update_option('hpwallart_taxes', $data['customization']['price']['vat']);
					update_option('woocommerce_calc_taxes', 'yes');
					update_option('woocommerce_prices_include_tax', 'no');
					update_option('woocommerce_shipping_tax_class', 'standard');
					
					//create a row in wp_woocommerce_tax_rates
					//search for a row
					$tax_search = $wpdb->get_row(" SELECT * FROM ".$wpdb->prefix."woocommerce_tax_rates WHERE tax_rate_name = 'VAT' AND tax_rate = '".$data['customization']['price']['vat'].".0000' ", 'ARRAY_A');
					//print_r($tax_search);
					$post_id = $tax_search['tax_rate_id'];
					
					//si no existe lo Add
					if(!$post_id)
					{
						$wpdb->query(" INSERT INTO ".$wpdb->prefix."woocommerce_tax_rates (tax_rate, tax_rate_name, tax_rate_priority, tax_rate_compound, tax_rate_shipping, tax_rate_order, tax_rate_class) VALUES ('".$data['customization']['price']['vat'].".0000', 'VAT', 1, 0, 1, 0, '') ");
					}
				}

				if($data['customization']['unit_system'] != '')
				{
					update_option('hpwallart_unit_system', $data['customization']['unit_system']);
				}

				//update use of applications
				foreach($data['applications'] as $k => $v)
				{
					// if($v['sku'] == 'PSTR') $v['sku'] ='WA_WP';
					if($v['status'] == '1') 
					{
						update_option('use_'.$v['sku'], 1);
					}
					else
					{
						update_option('use_'.$v['sku'], '');
					}
				}

				foreach($data['application_groups'] as $k2 => $v2)
				{
					foreach($v2['applications'] as $k => $v)
					{
						if($v['status'] == '1') 
						{
							update_option('use_'.$v['sku'], 1);
						}
						else
						{
							update_option('use_'.$v['sku'], '');
						}
					}
				}
			}
			
			//check parameter to parameter
			$fotolia_api_key = get_option('fotolia_api_key');
			$instagram_access_token = get_option('instagram_access_token');
			$big_stock_photo_account_id = get_option('big_stock_photo_account_id');
			$big_stock_photo_secret_key = get_option('big_stock_photo_secret_key');
			$pattern_design_api_key = get_option('pattern_design_api_key');
			$pattern_design_hmac_key = get_option('pattern_design_hmac_key');
			$items_per_page = get_option('items_per_page');
			$number_of_scenes = get_option('number_of_scenes');
			$number_of_elements = get_option('number_of_elements');
			$active_tooltip = get_option('active_tooltip');
			$hp_wallart_base_url = get_option('hp_wallart_base_url');
			$select_image_provider = get_option('select_image_provider');
			//$use_https = get_option('use_https');
			//$hpwallart_taxes = get_option('hpwallart_taxes');
			$dropbox_api_key = get_option('dropbox_api_key');
			$dropbox_api_secret = get_option('dropbox_api_secret');
			
			$set_page_principal = get_option('set_page_principal');
			
			global $wpdb;
			$wp_oauth_data = $wpdb->get_results(" SELECT * FROM wp_oauth_server_registry WHERE osr_id = '1' ", ARRAY_A);
			//echo '<pre>';print_r($wp_oauth_data);
			
			//1. Check uses
			$var['ok'] = '<img title="'.__("Correct", 'hpwallart' ).'" src="'.plugins_url( 'images/tick.png', __FILE__ ).'" />';
			$var['nok'] = '<img title="'.__("Correct", 'hpwallart' ).'" src="'.plugins_url( 'images/delete.png', __FILE__ ).'" />';
			?>
            <h4><?php _e("Customization", 'hpwallart' ); ?></h4>
            <table class="wp-list-table widefat fixed striped">
            <thead>
            <tr>
            	<th><?php _e("Parameter", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WP WallArt plugin", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WallArt account", 'hpwallart' ); ?></th>
                <th><?php _e("Status", 'hpwallart' ); ?></th>
            </tr>
            </thead>
            
            <tbody>
            <tr>
				<td><?php _e("URL Identifier", 'hpwallart' ); ?></td>
                <td><?php echo $hp_wallart_base_url; ?></td>
                <td><?php echo $data['customization']['url_identifier']; ?></td>
				<td><?php if($hp_wallart_base_url != $data['customization']['url_identifier']) echo $var['nok']; else echo $var['ok']; ?></td>
            </tr>

            <tr>
				<td><?php _e("Unit system", 'hpwallart' ); ?></td>
                <td>&nbsp;</td>
                <td><?php echo $data['customization']['unit_system']; ?></td>
                <td><?php _e("n/a", 'hpwallart' ); ?></td>
            </tr>

            <tr>
				<td><?php _e("Currency", 'hpwallart' ); ?></td>
                <td>&nbsp;</td>
                <td><?php echo $data['customization']['price']['currency_symbol']; ?></td>
                <td><?php _e("n/a", 'hpwallart' ); ?></td>
            </tr>

            <tr>
				<td><?php _e("Tax", 'hpwallart' ); ?></td>
                <td>&nbsp;</td>
                <td><?php echo $data['customization']['price']['vat']; ?> %</td>
                <td><?php _e("n/a", 'hpwallart' ); ?></td>
            </tr>
            </tbody>
            </table>

            <h4><?php _e("Applications", 'hpwallart' ); ?></h4>
            <table class="wp-list-table widefat fixed striped">
            <thead>
            <tr>
            	<th width="15%"><?php _e("Icon", 'hpwallart' ); ?></th>
            	<th><?php _e("Parameter", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WP WallArt plugin", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WallArt account", 'hpwallart' ); ?></th>
                <th><?php _e("Status", 'hpwallart' ); ?></th>
            </tr>
            </thead>
            
            <tbody>

            <!--2016-09-14 NEW update to show signage and others applications-->
            <?php
			//echo '<pre>'; print_r($data['applications']); echo '</pre>';
			foreach($data['applications'] as $k => $v)
			{
				// if($v['sku'] == 'PSTR') $v['sku'] ='WA_WP';
			?>
                <tr>
                    <td width="15%" valign="middle" align="left"><img style="width:32px;" src="<?php echo $v['icon']; ?>" alt="" /></td>
                    <td><?php _e($v['name'], 'hpwallart' ); ?></td>
                    <td><?php echo (get_option('use_'.$v['sku']) == '1')? 'YES' : 'NO' ?></td>
                    <td><?php echo ($v['status'] == '1')? 'YES' : 'NO' ?></td>
                    <td><?php if(get_option('use_'.$v['sku']) == '1' && $v['status'] == '1') echo $var['ok']; else echo $var['nok']; ?></td>
                </tr>
            <?php
			}

			//applications groups
			foreach($data['application_groups'] as $k => $v)
			{
				?>
				<?php
				foreach($v['applications'] as $k2 => $v2)
				{
			?>
				<tr>
                    <td width="15%" valign="middle" align="left"><img style="width:32px;" src="<?php echo $v2['icon']; ?>" alt="" /></td>
					<td><?php echo $v2['name']; ?></td>
					<td><?php echo (get_option('use_'.$v2['sku']) == true)? 'YES' : 'NO' ?></td>
					<td><?php echo ($v2['status'] == '1')? 'YES' : 'NO' ?></td>
					<td><?php if(get_option('use_'.$v2['sku']) == true && $v2['status'] == '1') echo $var['ok']; else echo $var['nok']; ?></td>
				</tr>	
			<?php
				}
			}
			?>
            
            </tbody>
            </table>

            <h4><?php _e("Production", 'hpwallart' ); ?></h4>
            <table class="wp-list-table widefat fixed striped">
            <thead>
            <tr>
            	<th><?php _e("Parameter", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WallArt account", 'hpwallart' ); ?></th>
                <th><?php _e("Status", 'hpwallart' ); ?></th>
            </tr>
            </thead>

            <tbody>
            <tr>
				<td><?php _e("Canvas frame width", 'hpwallart' ); ?></td>
                <td><?php echo $data['production']['canvas_frame_width']; ?></td>
                <td><?php _e("n/a", 'hpwallart' ); ?></td>
            </tr>

            <tr>
				<td><?php _e("Canvas frame type", 'hpwallart' ); ?></td>
                <td><?php echo $data['production']['canvas_frame_type']; ?></td>
                <td><?php _e("n/a", 'hpwallart' ); ?></td>
            </tr>

            <tr>
				<td><?php _e("Canvas size", 'hpwallart' ); ?></td>
                <td><?php echo $data['production']['canvas_size']; ?></td>
                <td><?php _e("n/a", 'hpwallart' ); ?></td>
            </tr>
            </tbody>
            </table>

			<!--Constrained dimensions-->
            <?php
			if($data['customization']['unit_system'] == 'Imperial')
			{
				 $factor = '0.3937';
				 $unit = 'in';
				 $divisor = '144';
			}
			elseif($hpwallart_unit_system == 'Metric')
			{
				 $factor = '1';
				 $unit = 'cm';
				 $divisor = '10000';
			}
			?>
            <h4><?php _e("Web Integration", 'hpwallart' ); ?></h4>
            <table class="wp-list-table widefat fixed striped">
            <thead>
            <tr>
            	<th><?php _e("Parameter", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WallArt plugin", 'hpwallart' ); ?></th>
                <th><?php _e("Settings in WallArt account", 'hpwallart' ); ?></th>
                <th width="10%"><?php _e("Status", 'hpwallart' ); ?></th>
            </tr>
            </thead>
			<?php
			if($data['web_integration']['access_token_based_authorization'] == '1')
			{
				$env =  (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off')? 'https' : 'http';
				
				//echo plugin_dir_url( __DIR__ ).'authorize.php';
            ?>
                <tr>
                    <td><?php _e("Authorization URL", 'hpwallart' ); ?></td>
                    <td><?php echo plugin_dir_url( __FILE__ ).'authorize.php'; ?></td>
                    <td><?php echo $data['web_integration']['authorization_url']; ?></td>
                    <td><?php if(plugin_dir_url( __FILE__ ).'authorize.php' != $data['web_integration']['authorization_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Service URL", 'hpwallart' ); ?></td>
                    <td><?php echo plugin_dir_url( __FILE__ ).'services.php'; ?></td>
                    <td><?php echo $data['web_integration']['service_url']; ?></td>
                    <td><?php if(plugin_dir_url( __FILE__ ).'services.php' != $data['web_integration']['service_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Content Hosting Site", 'hpwallart' ); ?></td>
                    <td><?php echo plugin_dir_url( __FILE__ ).'content.php'; ?></td>
                    <td><?php echo $data['web_integration']['content_hosting_site_url']; ?></td>
                    <td><?php if(plugin_dir_url( __FILE__ ).'content.php' != $data['web_integration']['content_hosting_site_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
			<?php
            }
			else
			{
			?>
            <tr>
                <td><?php _e("Oauth Consumer Key", 'hpwallart' ); ?></td>
                <td><?php echo $wp_oauth_data[0]['osr_consumer_key']; ?></td>
                <td><?php echo $data['web_integration']['oauth_consumer_key']; ?></td>
                <td><?php if($wp_oauth_data[0]['osr_consumer_key'] != $data['web_integration']['oauth_consumer_key']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Oauth Consumer Secret", 'hpwallart' ); ?></td>
                    <td><?php echo $wp_oauth_data[0]['osr_consumer_secret']; ?></td>
                    <td><?php echo $data['web_integration']['oauth_consumer_secret']; ?></td>
                    <td><?php if($wp_oauth_data[0]['osr_consumer_secret'] != $data['web_integration']['oauth_consumer_secret']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <!--URLS-->
                <tr>
                    <td><?php _e("Oauth Request Token Url", 'hpwallart' ); ?></td>
                    <td colspan="2"><?php echo $data['web_integration']['oauth_request_token_url']; ?></td>
                    <td><?php if(plugin_dir_url( __DIR__ ).'oauth/example/server/www/oauth.php/request_token' != $data['web_integration']['oauth_request_token_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Oauth User Authorization Url", 'hpwallart' ); ?></td>
                    <td colspan="2"><?php echo $data['web_integration']['oauth_user_authorization_url']; ?></td>
                    <td><?php if(plugin_dir_url( __DIR__ ).'oauth/example/server/www/oauth.php/authorize' != $data['web_integration']['oauth_user_authorization_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Oauth Access Token Url", 'hpwallart' ); ?></td>
                    <td colspan="2"><?php echo $data['web_integration']['oauth_access_token_url']; ?></td>
                    <td><?php if(plugin_dir_url( __DIR__ ).'oauth/example/server/www/oauth.php/access_token' != $data['web_integration']['oauth_access_token_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Oauth Service Url", 'hpwallart' ); ?></td>
                    <td colspan="2"><?php echo $data['web_integration']['service_url']; ?></td>
                    <td><?php if(plugin_dir_url( __DIR__ ).'oauth/example/server/www/services.php' != $data['web_integration']['service_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
    
                <tr>
                    <td><?php _e("Oauth Content Hosting Site Url", 'hpwallart' ); ?></td>
                    <td colspan="2"><?php echo $data['web_integration']['content_hosting_site_url']; ?></td>
                    <td><?php if(plugin_dir_url( __DIR__ ).'oauth/example/server/www/content.php' != $data['web_integration']['content_hosting_site_url']) echo $var['nok']; else echo $var['ok']; ?></td>
                </tr>
			<?php
			}
			?>
            </tbody>
            </table>

            </div>
		<?php
		}

		//help_page() displays the page content for the HP Wallart help 
		public function help_page()
		{
		?>
			<div class="wrap">
			<h2><?php echo __( 'Help', 'hpwallart' ); ?></h2>
			<?php include( plugin_dir_path( __FILE__ ) . 'documentation/help.php'); ?>
            </div>
		<?php
        }
			
		//plugins recommended or required
		public function my_theme_register_required_plugins()
		{
			/**
			 * Array of plugin arrays. Required keys are name and slug.
			 * If the source is NOT from the .org repo, then source is also required.
			 */
			$plugins = array(
				// This is an example of how to include a plugin from the WordPress Plugin Repository.
				array(
					'name'      => 'Font Awesome Icons',
					'slug'      => 'font-awesome',
					'required'  => false,
				),
		
				array(
					'name'      => 'WP Htaccess Editor',
					'slug'      => 'wp-htaccess-editor',
					'required'  => false,
				),
		
				array(
					'name'      => 'WooCommerce - excelling eCommerce',
					'slug'      => 'woocommerce',
					'required'  => true,
				),
		
				array(
					'name'      => 'Media Library Categories',
					'slug'      => 'wp-media-library-categories',
					'required'  => false,
				),
		
				array(
					'name'      => 'SVG Support',
					'slug'      => 'svg-support',
					'required'  => false,
				),
		
				// This is an example of how to include a plugin pre-packaged with a theme.		
			);

			/**
			 * Array of configuration settings. Amend each line as needed.
			 * If you want the default strings to be available under your own theme domain,
			 * leave the strings uncommented.
			 * Some of the strings are added into a sprintf, so see the comments at the
			 * end of each line for what each argument will be.
			 */
			$config = array(
				'default_path' => '',                      // Default absolute path to pre-packaged plugins.
				'menu'         => 'tgmpa-install-plugins', // Menu slug.
				'has_notices'  => true,                    // Show admin notices or not.
				'dismissable'  => true,                    // If false, a user cannot dismiss the nag message.
				'dismiss_msg'  => '',                      // If 'dismissable' is false, this message will be output at top of nag.
				'is_automatic' => false,                   // Automatically activate plugins after installation or not.
				'message'      => '',                      // Message to output right before the plugins table.
				'strings'      => array(
					'page_title'                      => __( 'Install Required Plugins', 'tgmpa' ),
					'menu_title'                      => __( 'Install Plugins', 'tgmpa' ),
					'installing'                      => __( 'Installing Plugin: %s', 'tgmpa' ), // %s = plugin name.
					'oops'                            => __( 'Something went wrong with the plugin API.', 'tgmpa' ),
					'notice_can_install_required'     => _n_noop( 'This plugin requires the following plugin: %1$s.', 'This plugin requires the following plugins: %1$s.' ), // %1$s = plugin name(s).
					'notice_can_install_recommended'  => _n_noop( 'This plugin recommends the following plugin: %1$s.', 'This plugin recommends the following plugins: %1$s.' ), // %1$s = plugin name(s).
					'notice_cannot_install'           => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s).
					'notice_can_activate_required'    => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s).
					'notice_can_activate_recommended' => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s).
					'notice_cannot_activate'          => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s).
					'notice_ask_to_update'            => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this plugin: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this plugin: %1$s.' ), // %1$s = plugin name(s).
					'notice_cannot_update'            => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s).
					'install_link'                    => _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
					'activate_link'                   => _n_noop( 'Begin activating plugin', 'Begin activating plugins' ),
					'return'                          => __( 'Return to Required Plugins Installer', 'tgmpa' ),
					'plugin_activated'                => __( 'Plugin activated successfully.', 'tgmpa' ),
					'complete'                        => __( 'All plugins installed and activated successfully. %s', 'tgmpa' ), // %s = dashboard link.
					'nag_type'                        => 'updated' // Determines admin notice type - can only be 'updated', 'update-nag' or 'error'.
				)
			);
			tgmpa( $plugins, $config );
		}

		static function create_media_categories()
		{
			$parent_term = term_exists( 'Objects', 'category' ); // array is returned if taxonomy is given
			
			if ($parent_term == 0 || $parent_term == NULL)
			{
				wp_insert_term(
				  'Objects', // the term 
				  'category', // the taxonomy
				  array(
					'description'=> 'Media Library objects',
					'slug' => 'objects',
					'parent'=> $parent_term_id
				  )
				);
			}
			$parent_term2 = term_exists( 'Backgrounds', 'category' ); // array is returned if taxonomy is given
			
			if ($parent_term2 == 0 || $parent_term2 == NULL)
			{
				wp_insert_term(
				  'Backgrounds', // the term 
				  'category', // the taxonomy
				  array(
					'description'=> 'Media Library backgrounds',
					'slug' => 'backgrounds',
					'parent'=> $parent_term_id2
				  )
				);
			}
		}
	
		//create oauth table estructure
		static function create_oauth_mysql()
		{
			global $wpdb;
			require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
			
			$sql = file_get_contents(dirname(__FILE__) . '/mysql.sql');
			$ps  = explode('#--SPLIT--', $sql);
			
			foreach ($ps as $p)
			{
				$p = preg_replace('/^\s*#.*$/m', '', $p);
				dbDelta( $p );
			}

			//rename tables with prefix
			$tables[] = "oauth_consumer_registry";
			$tables[] = "oauth_consumer_token";
			$tables[] = "oauth_log";
			$tables[] = "oauth_registro";
			$tables[] = "oauth_registro_hpwallart";
			$tables[] = "oauth_server_nonce";
			$tables[] = "oauth_server_registry";
			$tables[] = "oauth_server_token";

			foreach ($tables as $table)
			{
				//$wpdb->query(" RENAME TABLE $table TO ".$wpdb->prefix.$table." ");
				$wpdb->query(" RENAME TABLE $table TO wp_".$table." ");
			}

			//add initial data to oauth_server_registry
			$wpdb->insert( 
				//$wpdb->prefix.'oauth_server_registry', 
				'wp_oauth_server_registry', 
				array( 
					'osr_id' => '1', 
					'osr_usa_id_ref' => '1', 
					'osr_consumer_key' => 'a96508aa073354d8f6c93daf7675c467052095160', 
					'osr_consumer_secret' => 'a3f2acbfff0b53ad72c7f4fef22bad62', 
					'osr_enabled' => '1', 
					'osr_status' => 'active', 
					'osr_requester_name' => 'HP WallArt', 
					'osr_requester_email' => 'hpwallart.admin@hp.com', 
					'osr_callback_uri' => get_site_url(), 
					'osr_application_uri' => get_site_url(), 
					'osr_application_commercial' => '0', 
					'osr_issue_date' => date('Y-m-d H:i:s'), 
					'osr_timestamp' => date('Y-m-d H:i:s')
				)
			);
		}
		//uninstall plugin
		static function pluginUninstall()
		{
			//1. First delete tables 
			global $wpdb;
			require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
			
			$tables[] = "wp_oauth_consumer_registry";
			$tables[] = "wp_oauth_consumer_token";
			$tables[] = "wp_oauth_log";
			$tables[] = "wp_oauth_registro";
			$tables[] = "wp_oauth_registro_hpwallart";
			$tables[] = "wp_oauth_server_nonce";
			$tables[] = "wp_oauth_server_registry";
			$tables[] = "wp_oauth_server_token";

			foreach ($tables as $table)
			{
				$wpdb->query("DROP TABLE IF EXISTS $table");
			}
			
			//2. Second, delete variables
			delete_option('fotolia_api_key');
			delete_option('instagram_access_token');
			delete_option('big_stock_photo_account_id');
			delete_option('big_stock_photo_secret_key');
			delete_option('pattern_design_api_key');
			delete_option('pattern_design_hmac_key');
			delete_option('items_per_page');
			delete_option('number_of_scenes');
			delete_option('number_of_elements');
			delete_option('active_tooltip');
			delete_option('hp_wallart_base_url');
			delete_option('select_image_provider');
			delete_option('use_https');
			delete_option('dropbox_api_key');
			delete_option('dropbox_api_secret');
			delete_option('set_page_principal');
			delete_option('show_on_front');
			delete_option('page_on_front');
			delete_option('wallart_user');
			delete_option('wallart_password');
			delete_option('previous_page_on_front');
			delete_option('textconfig1');
			delete_option('textconfig2');
			delete_option('textconfig3');
			delete_option('textconfig4');
			delete_option('textconfig5');
			delete_option('textconfig6');
			
			$wpdb->query("DELETE FROM $wpdb->posts WHERE post_name = 'design' AND post_type = 'page' AND post_status = 'publish' ");
		}

		//deactivation plugin
		static function pluginDeactivate()
		{
			update_option('page_on_front', get_option('previous_page_on_front'));
			//delete_option('page_on_front');
			delete_option('previous_page_on_front');
		}
		
		//Set permalink manually
		static function set_permalinks() {
			global $wp_rewrite;
			$wp_rewrite->set_permalink_structure( '/%postname%/' );
		}
		
		//Set woocommerce options by default
		static function set_woocommerce_options() {

			update_option('woocommerce_enable_lightbox', "1");
			update_option('woocommerce_calc_taxes', "1");
			
			//woocommerce permalinks to "product"
			$permalinks = array('category_base' => '', 'tag_base' => '', 'attribute_base' => '', 'product_base' => '/producto');

			if (get_option('woocommerce_permalinks') !== false)
			{
				// The option already exists, so we just update it.
				update_option('woocommerce_permalinks', $permalinks );
			}
			else
			{
				// The option hasn't been added yet. We'll add it with $autoload set to 'no'.
				$deprecated = NULL;
				$autoload = 'no';
				add_option( 'woocommerce_permalinks', $permalinks, $deprecated, $autoload );
			}
		}
		
		//Set virtue as default template
		static function set_template_by_default() {
			update_option('template', "virtue");
			update_option('stylesheet', "virtue");
			update_option('current_theme', "virtue");
		}
		
		//Add custom page and category
		static function create_page()
		{
			register_taxonomy_for_object_type('design', 'page');
			 
			$PageGuid = site_url() . "/design";
			$my_post  = array( 'post_title'     => 'Design',
							   'post_type'      => 'page',
							   'post_name'      => 'design',
							   'post_content'   => '',
							   'post_status'    => 'publish',
							   'comment_status' => 'closed',
							   'ping_status'    => 'closed',
							   'post_author'    => 1,
							   'menu_order'     => 0,
							   'guid'           => $PageGuid );
			
			global $wpdb;
			$pageposts = $wpdb->get_results(" SELECT ID FROM $wpdb->posts WHERE post_name = 'design' AND post_type = 'page' AND post_status = 'publish' ", ARRAY_A);
			
			if(count($pageposts) == 0)
			{
				$id = wp_insert_post( $my_post, FALSE );
				
				//update page category
				update_post_meta($id, '_wp_page_template', 'design.php');
			}
		}
		
		//add or delete home page
		static function set_page_principal()
		{
			//change homepage. First set the previous homepage
			if(get_option('previous_page_on_front') == '')
			{
				update_option('previous_page_on_front', get_option('page_on_front'));
			}
			
			$set_page_principal = get_option('set_page_principal');
			
			global $wpdb;
			$pageposts = $wpdb->get_results(" SELECT ID FROM $wpdb->posts WHERE post_name = 'design' AND post_type = 'page' AND post_status = 'publish' ", ARRAY_A);
			
			if($set_page_principal == '1')
			{
				update_option('show_on_front', 'page');
				update_option('page_on_front', $pageposts[0]['ID']);
			}
			elseif($set_page_principal == '2')
			{
			
				update_option('page_on_front', get_option('previous_page_on_front'));
			}
		}

		//creamos las categorias si no existen
		static function wpse_insert_term()
		{
			//para evitar el error de "Fatal error: Call to undefined function wp_get_current_user()"
			if(!function_exists('wp_get_current_user'))
			{
				include(ABSPATH . "wp-includes/pluggable.php");
			}

			//get data from hpwallart
			$wallart_user = get_option('wallart_user');
			$wallart_password = get_option('wallart_password');
			$hp_wallart_base_url = get_option('hp_wallart_base_url');
			$wallart_key = get_option('wallart_key');

			if($wallart_key || ($wallart_user && $wallart_password))
			{
				$hp_wallart_base_url = get_option('hp_wallart_base_url');
				$host = 'https://hpwallart.com/'.$hp_wallart_base_url.'/settings_info';
				$process = curl_init($host);

				if($wallart_key){
					curl_setopt($process, CURLOPT_HTTPHEADER, array('X-API-KEY:'.$wallart_key));
			    }
				elseif($wallart_user && $wallart_password){
					curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type:application/json', "Authorization: Basic " . base64_encode($wallart_user . ":" . $wallart_password)));
			    }
			    else{
			    	 curl_setopt($process, CURLOPT_HTTPHEADER, array('X-API-KEY:'.$wallart_key));
			    }
				//curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type:application/json', "Authorization: Basic " . base64_encode($wallart_user . ":" . $wallart_password)));

				curl_setopt($process, CURLOPT_TIMEOUT, 300);
				curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
				curl_setopt($process, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
				$return = curl_exec($process);
				curl_close($process);
				$data = json_decode($return, true);
				update_option( 'wallart_data', serialize($data));
			}

			//insertamos categoria
			$terms = array();
			$i = 0;
			foreach($data['applications'] as $k => $v)
			{
				$terms[$i]['name'] = $v['name'];
				$terms[$i]['slug'] = $v['sku'];
				$terms[$i]['image'] = $v['images'][0];
				$i++;
			}
			
			foreach($data['application_groups'] as $k2 => $v2)
			{
				foreach($v2['applications'] as $k => $v)
				{
					$terms[$i]['name'] = $v2['name'].' '.$v['name'];
					$terms[$i]['slug'] = $v['sku'];
					$terms[$i]['image'] = $v['images'][0];
					$i++;
				}
			}

			require_once( ABSPATH . 'wp-admin/includes/image.php' );
			
			foreach($terms as $val)
			{
				wp_insert_term($val['name'], 'product_cat', array('description'=> $val['name'], 'slug' => $val['slug']));
			
				//formatC($val);
			
				//insertamos imagen
				if($val['image'] == '')
				{
					$val['image'] = "http://hpg.i.lithium.com/t5/image/serverpage/image-id/9942iD0870D49E38EBB16/image-size/original?v=v2&px=-1";
				}
				
				$upload_dir = wp_upload_dir();
				//formatC($upload_dir);
		
				//copiamos la imagen de base del plugin al directorio de UPLOADS
				//copy(dirname(__FILE__).'/images/'.$val['slug'].'.jpg', $upload_dir['path'].'/'.$val['slug'].'.jpg');
				copy($val['image'], $upload_dir['path'].'/'.$val['slug'].'.jpg');
				
				//obtenemos la ruta absoluta de la imagen
				$filename = $upload_dir['url'].'/'.$val['slug'].'.jpg';
				
				// Check the type of tile. We'll use this as the 'post_mime_type'.
				$filetype = wp_check_filetype( basename( $filename ), null );
		
				// Prepare an array of post data for the attachment.
				$attachment = array(
					'guid'           => $upload_dir['url'] . '/' . basename( $filename ),
					'post_mime_type' => $filetype['type'],
					'post_title'     => $val['name'],
					'post_author' => '1',
					'post_content' => '',
					'post_status' => "inherit",
					'post_parent' => '0',
					'post_type' => "attachment",
				);
		
				//Create post
				global $wpdb;
				
				$post_search = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."posts WHERE post_title = '".$val['slug']."' && post_status = 'inherit' && post_type = 'attachment' ", 'ARRAY_A');
				
				$attach_id = $post_search['ID'];
				
				if(!$attach_id)
				{
					$attach_id = wp_insert_attachment( $attachment, $filename, 0 );
				}
				
				//insertamos datos en woocommerce_term_meta
				$attach_data = wp_generate_attachment_metadata( $attach_id, $upload_dir['path'].'/'.$val['slug'].'.jpg' );
				wp_update_attachment_metadata( $attach_id,  $attach_data );
				$insert_id = term_exists( $val['name'], 'product_cat' );
				update_woocommerce_term_meta($insert_id['term_id'], 'thumbnail_id', $attach_id);
			}
			
			//create "external" category for products outside of hpwallart
			wp_insert_term('External', 'product_cat', array('description'=> 'External', 'slug' => 'external'));
		}

		//crear un producto
		public function createItem()
		{
			//access database
			global $wpdb;

			//get data from hpwallart
			$wallart_user = get_option('wallart_user');
			$wallart_password = get_option('wallart_password');
			$hp_wallart_base_url = get_option('hp_wallart_base_url');
			$wallart_key = get_option('wallart_key');

			if($wallart_key || ($wallart_user && $wallart_password))
			{
				$hp_wallart_base_url = get_option('hp_wallart_base_url');
				$host = 'https://hpwallart.com/'.$hp_wallart_base_url.'/settings_info';
				$process = curl_init($host);

				if($wallart_key){
					curl_setopt($process, CURLOPT_HTTPHEADER, array('X-API-KEY:'.$wallart_key));
			    }
				elseif($wallart_user && $wallart_password){
					curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type:application/json', "Authorization: Basic " . base64_encode($wallart_user . ":" . $wallart_password)));
			    }
			    else{
			    	 // curl_setopt($process, CURLOPT_HTTPHEADER, array('X-API-KEY:'.$wallart_key));
			    }

				//curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type:application/json', "Authorization: Basic " . base64_encode($wallart_user . ":" . $wallart_password)));

				curl_setopt($process, CURLOPT_TIMEOUT, 300);
				curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
				curl_setopt($process, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
				$return = curl_exec($process);
				curl_close($process);
				$data = json_decode($return, true);
				update_option( 'wallart_data', serialize($data) );
			}
			
			//Search media_substrate attribute
			$get_attribute_media = $wpdb->get_row(" SELECT * FROM ".$wpdb->prefix."woocommerce_attribute_taxonomies WHERE attribute_name = 'media_substrate' ", ARRAY_A);
			
			if(!count($get_attribute_media))
			{
				//Add attribute 
				$wpdb->insert("".$wpdb->prefix."woocommerce_attribute_taxonomies", array("attribute_name" => 'media_substrate', 'attribute_label' => 'Media Substrate', 'attribute_type' => 'select', 'attribute_orderby' => 'menu_order', 'attribute_public' => 0) );
				$get_attribute = $wpdb->get_row(" SELECT * FROM ".$wpdb->prefix."woocommerce_attribute_taxonomies WHERE attribute_name = 'media_substrate' ", ARRAY_A);
				$attribute_id = $get_attribute['attribute_id'];
				
				//select all attributes
				$attributes = $wpdb->get_row(" SELECT option_id, option_value FROM ".$wpdb->prefix."options WHERE option_name = '_transient_wc_attribute_taxonomies' ", ARRAY_A);
				$attributes = unserialize($attributes['option_value']);
				$num_rows = count($attributes);
				
				//add new attribute
				$attributes[$num_rows] = (object) array('attribute_id' => $attribute_id, 'attribute_name' => 'media_substrate', 'attribute_label' => 'Media Substrate', 'attribute_type' => 'select', 'attribute_orderby' => 'menu_order', 'attribute_public' => 0);
				update_option( '_transient_wc_attribute_taxonomies', $attributes );
			}
			else
			{
				$attribute_id = $get_attribute['attribute_id'];	
			}
				
			//array de productos
			$terms = array();
			$i = 0;
			foreach($data['applications'] as $k => $v)
			{
				$terms[$i]['title'] = $v['name'];
				$terms[$i]['abstract'] = $v['abstract'];
				$terms[$i]['slug'] = $v['sku'];
				$terms[$i]['tipo'] = $v['sku'];
				$terms[$i]['category'] = $v['name'];
				$terms[$i]['icon'] = $v['icon'];
				$terms[$i]['thumbnail'] = $v['images'][0];
				$terms[$i]['price'] = "0";
				
				$terms[$i]['available_attributes'] = array('media_substrate');

				if(count($v['materials']) > 0 && $v['materials'][0]['price_per_sqft'] > 0)
				{
					$terms[$i]['product_type'] = 'variable';
				}
				else
				{
					$terms[$i]['product_type'] = 'simple';
				}
				
				
				//variations
				if(count($v['materials']) > 0 && $v['materials'][0]['price_per_sqft'] > 0)
				{
					foreach($v['materials'] as $s => $p)
					{
						$terms[$i]['variations'][$s]['attributes'] = array('media_substrate' => $p['name']);
						$terms[$i]['variations'][$s]['description'] = $p['description'];
						$terms[$i]['variations'][$s]['hp_variation_id'] = $p['id'];
						
						switch($data['customization']['unit_system'])
						{
							case 'Metric' : $terms[$i]['variations'][$s]['price'] = $p['price_per_sqm']; break;
							case 'Imperial' : $terms[$i]['variations'][$s]['price'] = $p['price_per_sqft']; break;
						}
					}
				}
				$i++;
			}
			
			foreach($data['application_groups'] as $k2 => $v2)
			{
				foreach($v2['applications'] as $k => $v)
				{
					$terms[$i]['title'] = $v2['name'].' - '.$v['name'];
					$terms[$i]['abstract'] = $v['abstract'] != ''? $v['abstract'] : '';
					$terms[$i]['slug'] = $v['sku'];
					$terms[$i]['tipo'] = $v['sku'];
					$terms[$i]['category'] = $v2['name'].' '.$v['name'];
					$terms[$i]['icon'] = $v['icon'];
					$terms[$i]['thumbnail'] = $v['images'][0];
					$terms[$i]['price'] = "0";

					$terms[$i]['available_attributes'] = array('media_substrate');
	
					if(count($v['materials']) > 0 && $v['materials'][0]['price_per_sqft'] > 0)
					{
						$terms[$i]['product_type'] = 'variable';
					}
					else
					{
						$terms[$i]['product_type'] = 'simple';
					}
					
					//variations
					if(count($v['materials']) > 0 && $v['materials'][0]['price_per_sqft'] > 0)
					{
						foreach($v['materials'] as $s => $p)
						{
							$terms[$i]['variations'][$s]['attributes'] = array('media_substrate' => $p['name']);
							$terms[$i]['variations'][$s]['description'] = $p['description'];
							$terms[$i]['variations'][$s]['hp_variation_id'] = $p['id'];
							
							switch($data['customization']['unit_system'])
							{
								case 'Metric' : $terms[$i]['variations'][$s]['price'] = $p['price_per_sqm']; break;
								case 'Imperial' : $terms[$i]['variations'][$s]['price'] = $p['price_per_sqft']; break;
							}
						}
					}

					$i++;
				}
			}
			
			//para evitar el error de "Fatal error: Call to undefined function wp_get_current_user()"
			if(!function_exists('wp_get_current_user'))
			{
				include(ABSPATH . "wp-includes/pluggable.php");
			}

			foreach($terms as $val)
			{
				$post = array(
					'post_author' => '1',
					'post_content' => $val['title'],
					'post_status' => "publish",
					'post_title' => $val['title'],
					'post_parent' => '',
					'post_type' => 'product',
				);
				
				//search for the product if exists
				$post_search = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."posts WHERE post_title = '".$val['title']."' && post_status = 'publish' && post_type = 'product' ", 'ARRAY_A');
				
				$post_id = $post_search['ID'];
				
				//if no exists then add
				if(!$post_id)
				{
					$post_id = wp_insert_post( $post, $wp_error );
					update_post_meta($post_id, '_regular_price', $val['price'] );	
					update_post_meta($post_id, '_sale_price', $val['price'] );
					update_post_meta($post_id, '_price', $val['price'] );
					update_post_meta($post_id, '_type', $val['tipo'] );
					update_post_meta($post_id, '_sku', $val['slug'] );
					//update_post_meta($post_id, '_icon', $val['icon'] );
				}
				//else
				{		
					//buscamos categoria por el nombre
					$get_cat = $wpdb->get_row(" SELECT * FROM ".$wpdb->prefix."terms wt, ".$wpdb->prefix."term_taxonomy wtt WHERE name = '".$val['category']."' && wt.term_id = wtt.term_id ", 'ARRAY_A');
					
					//Add categoria al producto
					if($get_cat)
					{
						$wpdb->insert("".$wpdb->prefix."term_relationships", array("object_id" => $post_id, "term_taxonomy_id" => $get_cat['term_taxonomy_id'], "term_order" => 0) );
					}
					
					//Add tipo de producto (simple)
					wp_set_object_terms($post_id, $val['product_type'], 'product_type');
					
					
					//añadimos el thumbnail
					$thumbnail_search = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."posts WHERE post_title = '".$get_cat['slug']."' && post_status = 'inherit' && post_type = 'attachment' ", 'ARRAY_A');
					
					$thumbnail_id = $thumbnail_search['ID'];
					
					if($thumbnail_id)
					{
						update_post_meta($post_id, '_thumbnail_id', $thumbnail_id);	
					}
					
					//20/09/2016 add icon and thumbnail from Array
					
					update_post_meta($post_id, '_icon_path', $val['icon']);	
					update_post_meta($post_id, '_thumbnail_path', $val['thumbnail']);	
					
					HPWallart::insert_product_attributes($post_id, $val['available_attributes'], $val['variations']); // Add attributes passing the new post id, attributes & variations
					HPWallart::insert_product_variations($post_id, $val['variations']); // Insert variations passing the new post id & variations   					
				}
			}
		}
	
		//insert_product_attributes
		public function insert_product_attributes ($post_id, $available_attributes, $variations)
		{
			foreach ($available_attributes as $attribute) // Go through each attribute
			{
				$values = array(); // Set up an array to store the current attributes values.
		
				foreach ($variations as $variation) // Loop each variation in the file
				{
					$attribute_keys = array_keys($variation['attributes']); // Get the keys for the current variations attributes
		
					foreach ($attribute_keys as $key) // Loop through each key
					{
						if ($key === $attribute) // If this attributes key is the top level attribute add the value to the $values array
						{
							$values[] = $variation['attributes'][$key];
						}
					}
				}
		
				// Essentially we want to end up with something like this for each attribute:
				// $values would contain: array('small', 'medium', 'medium', 'large');
		
				$values = array_unique($values); // Filter out duplicate values
		
				// Store the values to the attribute on the new post, for example without variables:
				// wp_set_object_terms(23, array('small', 'medium', 'large'), 'pa_size');
				wp_set_object_terms($post_id, $values, 'pa_' . $attribute);
			}
		
			$product_attributes_data = array(); // Setup array to hold our product attributes data
		
			foreach ($available_attributes as $attribute) // Loop round each attribute
			{
				$product_attributes_data['pa_'.$attribute] = array( // Set this attributes array to a key to using the prefix 'pa'
		
					'name'         => 'pa_'.$attribute,
					'value'        => '',
					'is_visible'   => '1',
					'is_variation' => '1',
					'is_taxonomy'  => '1'
		
				);
			}
		
			update_post_meta($post_id, '_product_attributes', $product_attributes_data); // Attach the above array to the new posts meta data key '_product_attributes'
		}

		//insert_product_variations
		public function insert_product_variations ($post_id, $variations)
		{
			//access database
			global $wpdb;
			
			//
			//$this->formatC($variations);
			$get_old_product_variation = $wpdb->get_results(" SELECT * FROM ".$wpdb->prefix."posts WHERE post_parent = '".$post_id."' ", ARRAY_A);
            foreach ($get_old_product_variation as $oldvariationkey => $oldvariationvalue) {
            	wp_delete_post($oldvariationvalue['ID'], true);
            }

			foreach ($variations as $index => $variation)
			{
				//check if exist this variation in this product
				$get_product_variation = $wpdb->get_row(" SELECT ID FROM ".$wpdb->prefix."posts AS posts, ".$wpdb->prefix."postmeta AS postmeta WHERE posts.ID = postmeta.post_id AND posts.post_type = 'product_variation' AND posts.post_parent = '".$post_id."' AND postmeta.meta_key = '_hp_variation_id' AND postmeta.meta_value = '".$variation['hp_variation_id']."' ", ARRAY_A);
				
				//if not exists
				if(!count($get_product_variation))
				{
					$variation_post = array( // Setup the post data for the variation
			
						//'post_title'  => 'Variation #'.$index.' of '.count($variations).' for product#'. $post_id,
						'post_title'  => $variation['attributes']['media_substrate'],
						//'post_name'   => 'product-'.$post_id.'-variation-'.$index,
						'post_status' => 'publish',
						'post_parent' => $post_id,
						'post_type'   => 'product_variation',
						'guid'        => home_url() . '/?product_variation=product-' . $post_id . '-variation-' . $index
					);
			
					$variation_post_id = wp_insert_post($variation_post); // Insert the variation
			
					foreach ($variation['attributes'] as $attribute => $value) // Loop through the variations attributes
					{  
						$attribute_term = get_term_by('name', $value, 'pa_'.$attribute); // We need to insert the slug not the name into the variation post meta
			
						update_post_meta($variation_post_id, 'attribute_pa_'.$attribute, $attribute_term->slug);
					  // Again without variables: update_post_meta(25, 'attribute_pa_size', 'small')
					}
			
					update_post_meta($variation_post_id, '_price', $variation['price']);
					update_post_meta($variation_post_id, '_regular_price', $variation['price']);
					update_post_meta($variation_post_id, '_variation_description', $variation['description']);
					update_post_meta($variation_post_id, '_hp_variation_id', $variation['hp_variation_id']);
				}
				else	//update values
				{
					$variation_post_id = $get_product_variation['ID'];
					update_post_meta($variation_post_id, 'attribute_pa_media_substrate', sanitize_title_with_dashes($variation['attributes']['media_substrate']));
					update_post_meta($variation_post_id, '_price', $variation['price']);
					update_post_meta($variation_post_id, '_regular_price', $variation['price']);
					update_post_meta($variation_post_id, '_variation_description', $variation['description']);
				}
			}
		}

		public function normalize ($string) {
			$table = array(
				'Š'=>'S', 'š'=>'s', 'Đ'=>'Dj', 'đ'=>'dj', 'Ž'=>'Z', 'ž'=>'z', 'Č'=>'C', 'č'=>'c', 'Ć'=>'C', 'ć'=>'c',
				'À'=>'A', 'Á'=>'A', 'Â'=>'A', 'Ã'=>'A', 'Ä'=>'A', 'Å'=>'A', 'Æ'=>'A', 'Ç'=>'C', 'È'=>'E', 'É'=>'E',
				'Ê'=>'E', 'Ë'=>'E', 'Ì'=>'I', 'Í'=>'I', 'Î'=>'I', 'Ï'=>'I', 'Ñ'=>'N', 'Ò'=>'O', 'Ó'=>'O', 'Ô'=>'O',
				'Õ'=>'O', 'Ö'=>'O', 'Ø'=>'O', 'Ù'=>'U', 'Ú'=>'U', 'Û'=>'U', 'Ü'=>'U', 'Ý'=>'Y', 'Þ'=>'B', 'ß'=>'Ss',
				'à'=>'a', 'á'=>'a', 'â'=>'a', 'ã'=>'a', 'ä'=>'a', 'å'=>'a', 'æ'=>'a', 'ç'=>'c', 'è'=>'e', 'é'=>'e',
				'ê'=>'e', 'ë'=>'e', 'ì'=>'i', 'í'=>'i', 'î'=>'i', 'ï'=>'i', 'ð'=>'o', 'ñ'=>'n', 'ò'=>'o', 'ó'=>'o',
				'ô'=>'o', 'õ'=>'o', 'ö'=>'o', 'ø'=>'o', 'ù'=>'u', 'ú'=>'u', 'û'=>'u', 'ý'=>'y', 'ý'=>'y', 'þ'=>'b',
				'ÿ'=>'y', 'Ŕ'=>'R', 'ŕ'=>'r',
			);
		
			return strtr($string, $table);
		}
		
		//delete products and variations
		static function deleteItems()
		{
			//access database
			global $wpdb;

			//get data from hpwallart
			
			$data = unserialize(get_option('wallart_data'));
			
			
			//21/02/2017 First we need delete all the previous products and variatiosn. Depending the category or name
			foreach($data['applications'] as $k => $v)
			{
				$get_product = $wpdb->get_results(" SELECT * FROM ".$wpdb->prefix."posts WHERE post_title = '".$v['name']."' ", ARRAY_A);
				
				if(count($get_product))
				{
					foreach($get_product as $pro => $var)
					{
						//delete product and variations
						wp_delete_post($var['ID'], true);
						
						$get_product_variations = $wpdb->get_results(" SELECT * FROM ".$wpdb->prefix."posts WHERE post_parent = '".$var['ID']."' ", ARRAY_A);
						
						if(count($get_product_variations))
						{
							foreach($get_product_variations as $pro2 => $var2)
							{
								wp_delete_post($var2['ID'], true);
							}
						}
					}
				}
			}

			foreach($data['application_groups'] as $k2 => $v2)
			{
				foreach($v2['applications'] as $k => $v)
				{
					$get_product = $wpdb->get_results(" SELECT * FROM ".$wpdb->prefix."posts WHERE post_title = '".$v['name']."' ", ARRAY_A);
					
					if(count($get_product))
					{
						foreach($get_product as $pro => $var)
						{
							//delete product and variations
							wp_delete_post($var['ID'], true);
							
							$get_product_variations = $wpdb->get_results(" SELECT * FROM ".$wpdb->prefix."posts WHERE post_parent = '".$var['ID']."' ", ARRAY_A);
							
							if(count($get_product_variations))
							{
								foreach($get_product_variations as $pro2 => $var2)
								{
									wp_delete_post($var2['ID'], true);
								}
							}
						}
					}
				}
			}
		}

		//overridde woocommerce plugin templates
		public function myplugin_plugin_path() {
		 
		  // gets the absolute path to this plugin directory
		  return untrailingslashit( plugin_dir_path( __FILE__ ) );
		 
		}

		public function myplugin_woocommerce_locate_template( $template, $template_name, $template_path )
		{
			global $woocommerce;
			 
			$_template = $template;
		 
			if (!$template_path )
			{
				$template_path = $woocommerce->template_url;
			}
		 
			$plugin_path  = $this->myplugin_plugin_path() . '/woocommerce/';
			//formatC($plugin_path.$template_name);			  
			//check for plugin override first:
			if (file_exists($plugin_path . $template_name))
			{
				return $plugin_path.$template_name;
			}
		 
			// THEN Look within the theme
		 
			$template = locate_template(
		 
				array($template_path . $template_name, $template_name)
			);
			
		 
			// Use default template
		 
			if (!$template)
			{
				$template = $_template;
			}
		 
			// Return what we found
			return $template;
		}
	
		//disable load
		public function remove_custom_scripts()
		{
			wp_dequeue_style('google-webfonts');
			wp_dequeue_script('wplms-events-gmaps-js');
		}
	
		public function mw_enqueue_color_picker( $hook_suffix ) {
			// first check that $hook_suffix is appropriate for your admin page
			wp_enqueue_style( 'wp-color-picker' );
			wp_enqueue_script( 'my-script-handle', plugins_url('js/admin.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
		}
	}

	add_action( 'plugins_loaded', array( 'HPWallart', 'get_instance' ) );
	register_activation_hook( __FILE__, array( 'HPWallart', 'wpse_insert_term' ) );
	//register_activation_hook( __FILE__, array( 'HPWallart', 'deleteItems' ) );
	register_activation_hook( __FILE__, array( 'HPWallart', 'createItem' ) );
	register_activation_hook( __FILE__, array( 'HPWallart', 'set_permalinks' ) );
	register_activation_hook( __FILE__, array( 'HPWallart', 'create_page' ) );
	register_activation_hook( __FILE__, array( 'HPWallart', 'create_oauth_mysql' ) );
	register_activation_hook( __FILE__, array( 'HPWallart', 'set_woocommerce_options' ) );
	//register_activation_hook( __FILE__, array( 'HPWallart', 'set_template_by_default' ) );

	register_uninstall_hook( __FILE__, array( 'HPWallart', 'pluginUninstall' ) );
	register_deactivation_hook( __FILE__, array( 'HPWallart', 'pluginDeactivate' ) );

	//cargamos archivos de idiomas
	load_plugin_textdomain('hpwallart', false, basename( dirname( __FILE__ ) ) . '' );

	///////////////////////////////////////////

	class PageTemplater 
	{
		/**
         *A Unique Identifier
         */
		protected $plugin_slug;

        /**
         *A reference to an instance of this class.
         */
        private static $instance;

        /**
         *The array of templates that this plugin tracks.
         */
        protected $templates;


        /**
         *Returns an instance of this class. 
         */
        public static function get_instance() {

                if( null == self::$instance ) {
                        self::$instance = new PageTemplater();
                } 
                return self::$instance;
        }

        /**
         *Initializes the plugin by setting filters and administration functions.
         */
        private function __construct() {

                $this->templates = array();

                // Add a filter to the attributes metabox to inject template into the cache.
                add_filter('page_attributes_dropdown_pages_args', array( $this, 'register_project_templates' ));

                // Add a filter to the save post to inject out template into the page cache
                add_filter('wp_insert_post_data', array( $this, 'register_project_templates' ) );

                // Add a filter to the template include to determine if the page has our 
				// template assigned and return it's path
                add_filter('template_include', array( $this, 'view_project_template') );

                // Add your templates to this array.
                $this->templates = array(
                        'design.php'     => 'Design',
                );
				
				add_action( 'wp_enqueue_scripts', array( $this, 'register_plugin_styles' ) );
        }

        /**
         *Adds our template to the pages cache in order to trick WordPress
         *into thinking the template file exists where it doens't really exist.
         *
         */
        public function register_project_templates( $atts ) {

                // Create the key used for the themes cache
                $cache_key = 'page_templates-' . md5( get_theme_root() . '/' . get_stylesheet() );

                // Retrieve the cache list. 
				// If it doesn't exist, or it's empty prepare an array
				$templates = wp_get_theme()->get_page_templates();
                if ( empty( $templates ) ) {
                        $templates = array();
                }

                // New cache, therefore remove the old one
                wp_cache_delete( $cache_key , 'themes');

                // Now add our template to the list of templates by merging our templates
                // with the existing templates array from the cache.
                $templates = array_merge( $templates, $this->templates );

                // Add the modified cache to allow WordPress to pick it up for listing
                // available templates
                wp_cache_add( $cache_key, $templates, 'themes', 1800 );

                return $atts;
        }

        /**
         *Checks if the template is assigned to the page
         */
        public function view_project_template( $template ) {

                global $post;

                if (!isset($this->templates[get_post_meta(
					$post->ID, '_wp_page_template', true 
				)] ) ) {
					
                        return $template;		
                }

                $file = plugin_dir_path(__FILE__). get_post_meta(
					$post->ID, '_wp_page_template', true 
				);
				
                // Just to be safe, we check if the file exist first
                if( file_exists( $file ) ) {
                    return $file;
                }
				else { echo $file; }

                return $template;
        }

		/**
		 * Register and enqueue style sheet.
		 */
		public function register_plugin_styles() {
			wp_register_style( 'hpwallart', plugins_url( 'hpwallart/css/estilos.css' ) );
			wp_enqueue_style( 'hpwallart' );
			wp_register_style( 'hpwallartmobile', plugins_url( 'hpwallart/css/mobile.css' ) );
			wp_enqueue_style( 'hpwallartmobile' );
			wp_enqueue_script( 'hpwallart', plugins_url( 'hpwallart/js/funcionalidades.js'), false );
			wp_localize_script('hpwallart', 'myScript', array('pluginsUrl' => plugins_url()));
		}
	}
	add_action( 'plugins_loaded', array( 'PageTemplater', 'get_instance' ) );
	//register_activation_hook(__FILE__, array( 'PageTemplater', 'install' ));	
	
	if (!session_id()) {
		session_name('PHPSESSID');
		session_start();
	}
?>