<?php 
	/**
		 @contact   HP WallArt Barcelona Team (abad@hp.com)
	 
		 @version   1.0
		 @date Feb 1 2015
	 
	*   (c) Copyright 2015 Hewlett-Packard Development Company L.P
	*   All rights reserved. Copying or other reproduction of this
	*   program except for archival purposes is prohibited without
	*   written consent of HP Inc.
	*
	*   HP / GSB / LFPro
	*/

	function woo_get_featured_product_ids() 
	{
		$args = array( 'post_type' => 'product', 'posts_per_page' => -1); 
	
		$loop = new WP_Query( $args );
	
		while ( $loop->have_posts() ) : $loop->the_post(); 
		global $product; 
		$products[$product->id] = $product->post;
		//$products[$product->id]->price = get_post_meta($product->id, '', true);
		$products[$product->id]->price = get_post_meta( $product->id, '_price', true);
		$products[$product->id]->type = get_post_meta( $product->id, '_type', true);
		//$products[$product->id]->thumbnail = wp_get_attachment_url( get_post_thumbnail_id() );
		$products[$product->id]->icon = get_post_meta( $product->id, '_icon_path', true);
		$products[$product->id]->thumbnail = get_post_meta( $product->id, '_thumbnail_path', true);
		
		if ( $product->is_type( 'variable' ) )
		{
			$products[$product->id]->variations = $product->get_available_variations();
		}
		else
		{
			$products[$product->id]->variations = NULL;
		}
		
	//	echo '<br /><a href="'.get_permalink().'">' . woocommerce_get_product_thumbnail().' '.the_title().'</a>';
		endwhile; 
	
	
		wp_reset_query(); 	
		return $products;
	}
	
	
	$PRODUCTS = woo_get_featured_product_ids();
	
	if(isset($_GET['show_me']) && $_GET['show_me'] == 'yes')
	{
		formatC($PRODUCTS, 0);
	}
	
	//GET VAT %
	$hpwallart_taxes = 1+get_option('hpwallart_taxes')/100;
	
	$hpwallart_unit_system = get_option('hpwallart_unit_system');
	
	if($hpwallart_unit_system == 'Imperial')
	{
		 $factor = '0.3937';
		 $unit = 'in';
		 $square = 'ft&sup2;';
		 $divisor = '144';
	}
	elseif($hpwallart_unit_system == 'Metric')
	{
		 $factor = '1';
		 $unit = 'cm';
		 $square = 'm&sup2;';
		 $divisor = '10000';
	}
	
	$provider = array();

	foreach($PRODUCTS as $k => $v)
	{
		$provider[$v->type]['backgrounds'] = get_option($v->type.'_backgrounds');
		$provider[$v->type]['objects'] = get_option($v->type.'_objects');
	}
	//formatC($provider, 0);
	
	//Navartic 2017-04-04::New implement of sizes
	//$data_hpwallart = unserialize(get_option('wallart_data'));
	//formatC($data_hpwallart, 0);

	//Robosoft 2018-03-14::Enable and disable a custom sizes
	foreach($data_hpwallart['applications'] as $k => $v)
	{
		$presets[$v['sku']]['presets_enabled'] = $v['presets_enabled'];	
		$presets[$v['sku']]['custom_enabled'] = $v['custom_enabled'];	
		$presets[$v['sku']]['presets'] = $v['presets'];	
		$presets[$v['sku']]['use_backgrounds_step'] = $v['backgrounds'];	
	}

	foreach($data_hpwallart['application_groups'] as $k2 => $v2)
	{
		foreach($v2['applications'] as $k => $v)
		{
			$presets[$v['sku']]['presets_enabled'] = $v['presets_enabled'];
			$presets[$v['sku']]['custom_enabled'] = $v['custom_enabled'];	
			$presets[$v['sku']]['presets'] = $v['presets'];	
			$presets[$v['sku']]['use_backgrounds_step'] = $v['backgrounds'];	
		}
	}
	// /Robosoft End/ 
	
	$apps = array_keys($presets);

	require_once(dirname(__FILE__).'/navigation.php');
?>
<script>
    function calculate(ancho, alto, factor, divisor, unitate)
    {
		//document.getElementById('log').innerHTML = 'Factor: '+factor+' Dimensiones: '+ancho+' x '+alto+' Divisor: '+divisor;     
		//alert('Factor: '+factor+' Dimensiones: '+ancho+' x '+alto+' Divisor: '+divisor);     

		<?php
		if($hpwallart_unit_system == 'Imperial')
		{
		?>
			var factorImp = 1;
		<?php
		}
		elseif($hpwallart_unit_system == 'Metric')
		{
		?>
			var factorImp = 0.393701;
		<?php
		}
		?>
		
		
		
			
		//Navartic 2017-04-04::New implement of sizes
		
		
		<?php
		//Merge array of applications and applications_group
		foreach($data_hpwallart['application_groups'] as $k2 => $v2)
		{
			foreach($v2['applications'] as $k => $v)
			{
				$application_groups[] = $v;	
			}
		}
		
		$applications = array_merge($data_hpwallart['applications'], $application_groups);
		//formatC($applications);
		
		foreach($applications as $k => $v)
		{
			$sizes = $v['sizes'][0];
		?>
			if(document.getElementById('categoria').value == '<?php echo $v['sku']; ?>')
			{
				//var metros = ancho*alto/divisor;
				
				var bandera = false;
				
				if((ancho == '-1') && (alto == '-1')){
                    var bandera = false;
				}else{
					if(ancho < parseFloat(parseFloat(<?php echo $sizes['minwidth']; ?>/factorImp).toFixed(2)) )
					{
						alert("<?php echo __( 'The minimum width for '.$v['name'].' is ', 'hpwallart'); ?>"+(<?php echo $sizes['minwidth']; ?>/factorImp).toFixed(2)+" "+unitate);
						document.getElementById('skusancho').value = (<?php echo $sizes['minwidth']; ?>/factorImp).toFixed(2);
						//metros = ((alto*(<?php echo $sizes['minwidth']; ?>/factorImp))/divisor).toFixed(2);
						bandera = true;
					}
					
					if(ancho > parseFloat(parseFloat(<?php echo $sizes['maxwidth']; ?>/factorImp).toFixed(2)) )
					{
						alert("<?php echo __( 'The maximum width for '.$v['name'].' is ', 'hpwallart'); ?>"+(<?php echo $sizes['maxwidth']; ?>/factorImp).toFixed(2)+" "+unitate);
						document.getElementById('skusancho').value = (<?php echo $sizes['maxwidth']; ?>/factorImp).toFixed(2);
						//metros = ((alto*(<?php echo $sizes['maxwidth']; ?>/factorImp))/divisor).toFixed(2);
						bandera = true;
					}
					
					if(alto > parseFloat(parseFloat(<?php echo $sizes['maxheight']; ?>/factorImp).toFixed(2)) )
					{
						alert("<?php echo __( 'The maximum height for '.$v['name'].' is ', 'hpwallart'); ?>"+(<?php echo $sizes['maxheight']; ?>/factorImp).toFixed(2)+" "+unitate);
						document.getElementById('skusalto').value = (<?php echo $sizes['maxheight']; ?>/factorImp).toFixed(2);
						//metros = ((ancho*(<?php echo $sizes['maxheight']; ?>/factorImp))/divisor).toFixed(2);
						bandera = true;
					}
					
					if(alto < parseFloat(parseFloat(<?php echo $sizes['minheight']; ?>/factorImp).toFixed(2)) )
					{
						alert("<?php echo __( 'The minimum height for '.$v['name'].' is ', 'hpwallart'); ?>"+(<?php echo $sizes['minheight']; ?>/factorImp).toFixed(2)+" "+unitate);
						document.getElementById('skusalto').value = (<?php echo $sizes['minheight']; ?>/factorImp).toFixed(2);
						//metros = ((ancho*(<?php echo $sizes['minheight']; ?>/factorImp))/divisor).toFixed(2);
						bandera = true;
					}
				}
				
				if(bandera == false)
				{
					document.getElementById('skusancho').value = ancho;
					document.getElementById('skusalto').value = alto;
					//metros = (ancho*alto)/divisor;
				}
			}
			
		<?php	
		}
		?>

		var ancho2 = document.getElementById('skusancho').value;
		var alto2 = document.getElementById('skusalto').value;
		var metros = (ancho2*alto2)/divisor;
		//alert(metros);
       
        
        var precios = new Array();

        <?php
        foreach($PRODUCTS as $key => $value)
        {
        ?>
            precios[<?php echo $key ?>] = '<?php echo $value->price ?>';
        <?php
			if(count($value->variations))
			{
				foreach($value->variations as $s => $v)
				{
				?>
					precios[<?php echo $v['variation_id'] ?>] = '<?php echo $v['display_price'] ?>';
				<?php
				}
			}
        }
        ?>
        
		//get currency to show
		var currency = '<?php echo get_option('woocommerce_currency'); ?>';

		//document.getElementById('variation').value = variation;
		//document.getElementById('tipo').value = variation;
	        
        
        var res = metros*precios[document.getElementById('tipo').value]; 
        //alert(res);
		//alert(precios[document.getElementById('tipo').value]);
		
		if(res > 0)
        {
            document.getElementById("precioDiv").style.display="block";
			document.getElementById("precioDiv").innerHTML  = '<h3><?php echo __( 'Price', 'hpwallart' ); ?></h3><span style="color:#555555; font-size:2em; font-weight:bold; padding:0.0em 0; margin:0;">'+((res).toFixed(2))+' '+currency+'</span><p style="text-transform:none; margin:0; font-size:1em; color:#000;">'+((res*<?php echo $hpwallart_taxes; ?>).toFixed(2))+' '+currency+' <?php echo __( 'Taxes included.', 'hpwallart' ); ?></p><p style="text-transform:none; margin:0; font-size:1em; color:#000;"><?php echo __( 'Delivery and other charges not included.', 'hpwallart' ); ?></p>';
            document.getElementById("precioAproximado").value  = (res).toFixed(2);
            document.getElementById("precioBase").value  = precios[document.getElementById('tipo').value];
			
			$("#precioDiv").load('<?php echo plugin_dir_url( __FILE__ ) ; ?>precioDiv.php?price='+((res).toFixed(2))+'&currency='+currency+'&hpwallart_taxes=<?php echo $hpwallart_taxes; ?>' );
			
			<?php
			if($use_backgrounds == 1 || $use_objects == 1)
			{
			?>
				document.getElementById('nextStep').style.display='inline';
			<?php
			}
			?>
        }
    }
    </script>


    
    <?php
    if($_SESSION['resultado']['status'] == 'medidas')
    {
    ?>
    <div id="error">
        <?php echo $_SESSION['resultado']['respuesta'] ?>
    </div>
    <?php 
    }
    ?>
    <div id="cajaFormularioMedidas" style="width:100%;">
        <form action="" id="myFormi" method="get" enctype="multipart/form-data" autocomplete="on">
        <fieldset>
            <legend></legend>
            <!--<label class="required" for="proyecto"><?php echo $STR['lateral'][8] ?></label>
            <input class="required" type="text" name="proyecto" id="proyecto" size="40" value="<?php echo $_SESSION['basket']['proyecto']?$_SESSION['basket']['proyecto'] : 'nuevo proyecto' ?>" />-->
    		
            <?php
			if($use_backgrounds == '1' && $_SESSION['basket']['use_backgrounds_step'] == '1') 
			{
				$paso = '2';	
			}
			else
			{
				$paso = '3';	
			}
			?>
            <input type="hidden" name="paso" value="<?php echo $paso; ?>" id="paso" />
            <input type="hidden" name="action" value="medidas" id="action" />
            <input type="hidden" name="product_id" value="<?php echo $_SESSION['basket']['product_id']? $_SESSION['basket']['product_id'] : '' ?>" id="product_id" />
            <input type="hidden" name="variation" value="<?php echo $_SESSION['basket']['variation']? $_SESSION['basket']['variation'] : '' ?>" id="variation" />
            <input type="hidden" name="tipo" value="<?php echo $_SESSION['basket']['tipo']?$_SESSION['basket']['tipo'] : '' ?>" id="tipo" />
            <input type="hidden" name="type" value="<?php echo $_SESSION['basket']['type']?$_SESSION['basket']['type'] : '' ?>" id="type" />
            <input type="hidden" name="media_substrate" value="<?php echo $_SESSION['basket']['media_substrate']?$_SESSION['basket']['media_substrate'] : '' ?>" id="media_substrate" />

            <input type="hidden" name="use_backgrounds_step" value="<?php echo $_SESSION['basket']['use_backgrounds_step']?$_SESSION['basket']['use_backgrounds_step'] : '' ?>" id="use_backgrounds_step" />

            <!--<input type="hidden" name="provider_backgrounds" value="<?php echo $_SESSION['basket']['provider_backgrounds']?$_SESSION['basket']['provider_backgrounds'] : '' ?>" id="provider_backgrounds" />
            <input type="hidden" name="provider_objects" value="<?php echo $_SESSION['basket']['provider_objects']?$_SESSION['basket']['provider_objects'] : '' ?>" id="provider_objects" />-->

            <input type="hidden" name="categoria" value="<?php echo $_SESSION['basket']['categoria']?$_SESSION['basket']['categoria'] : '' ?>" id="categoria" />
            <input type="hidden" name="soporte" value="<?php echo $_SESSION['basket']['soporte']?$_SESSION['basket']['soporte'] : '' ?>" id="soporte" />
            <input type="hidden" name="precioAproximado" value="<?php echo $_SESSION['basket']['precioAproximado']?$_SESSION['basket']['precioAproximado'] : '' ?>" id="precioAproximado" />
            <input type="hidden" name="precioBase" value="<?php echo $_SESSION['basket']['precioBase']?$_SESSION['basket']['precioBase'] : '' ?>" id="precioBase" />
            
			<div id="log"></div>
			<div id="lateral">
                <div class="cajaFormularioLateral" id="precioDiv" style="clear:both; display:none;">
                    <h3 id="precio" style="color:#000; background-color:#ececec;"><?php echo __( 'Price', 'hpwallart' ); ?><br><p style="text-transform:none; margin:0; font-size:0.7em; color:#000;"><?php echo __( 'VAT and delivery fees not included.', 'hpwallart' ); ?></p></h3>
                </div>

                <!--VARIATIONS-->
                <div class="cajaFormularioLateral" id="VARIATIONS" style="clear:both; display:none;"></div>

               <!-- /Robosoft 2018-03-14::Enable and disable a custom sizes/ -->
                <div id="SKUS" style=" <?php echo ' display:none;'; ?>">
               <!--  	/Robosoft End/  -->
                	<div class="cajaFormularioLateral">
					<?php
					if($use_backgrounds != 1 && $use_objects != 1)	//not scenes nor objects
					{
					?>
						<h3><?php echo __( 'Dimensions', 'hpwallart' ); ?></h3>
						<div id="botones" style="clear:both; float:left; width:75%;">
							<p><?php echo __( 'Enter the width and height:', 'hpwallart' ); ?></p>
							<label class="required" for="ancho"><?php echo __( 'Width', 'hpwallart' ); ?></label>
							<input class="required" type="number" name="ancho" id="skusancho" style="width:70px;" value="<?php echo $_SESSION['basket']['ancho'] ?>" /><span style="float:left; font-weight:normal; padding-top:1em; font-size:1em;">&nbsp;<?php echo $unit; ?></span>
							
							<label class="required" for="alto"><?php echo __( 'Height', 'hpwallart' ); ?></label>
							<input class="required" type="number" name="alto" id="skusalto" style="width:70px;" value="<?php echo $_SESSION['basket']['alto'] ?>" /><span style="float:left; font-weight:normal; padding-top:1em; font-size:1em;">&nbsp;<?php echo $unit; ?></span>
		
							<label for="boton"></label>
							<input class="recalcular" name="boton" type="button" onclick="calculate(document.getElementById('skusancho').value, document.getElementById('skusalto').value, '<?php echo $factor; ?>', '<?php echo $divisor; ?>', '<?php echo $unit; ?>'); document.getElementById('myFormi').submit();" value="<?php echo __( 'Calculate', 'hpwallart' ); ?>" />
						</div>
					<?php
					}
					else
					{
					?>
                        <h3><?php echo __( 'Dimensions', 'hpwallart' ); ?></h3>
                        <div id="botones" style="clear:both; float:left; width:100%;">
                            <p><?php echo __( 'Enter the width and height:', 'hpwallart' ); ?></p>
                            <label class="required" for="ancho"><?php echo __( 'Width', 'hpwallart' ); ?></label>
                            <input class="required" type="number" name="ancho" id="skusancho" style="width:70px;" value="<?php echo $_SESSION['basket']['ancho'] ?>" /><span style="float:left; font-weight:normal; padding-top:1em; font-size:1em;">&nbsp;<?php echo $unit; ?></span>
                            
                            <label class="required" for="alto"><?php echo __( 'Height', 'hpwallart' ); ?></label>
                            <input class="required" type="number" name="alto" id="skusalto" style="width:70px;" value="<?php echo $_SESSION['basket']['alto'] ?>" /><span style="float:left; font-weight:normal; padding-top:1em; font-size:1em;">&nbsp;<?php echo $unit; ?></span>
                            
                            <label for="boton"></label>
                            <input class="recalcular" name="boton" type="button" onclick="calculate(document.getElementById('skusancho').value, document.getElementById('skusalto').value, '<?php echo $factor; ?>', '<?php echo $divisor; ?>', '<?php echo $unit; ?>')" value="<?php echo __( 'Calculate', 'hpwallart' ); ?>" />
                        </div>
                    <?php
					}
					?>
                    </div>
                </div>
			            
                <div id="CANVAS" <?php if($_SESSION['basket']['type'] == '') echo 'style="display:none;"'; ?>></div>
                
        	</div>
            
            <!--HERE THE APPLICATIONS-->
            <div id="botones">
                <!--<h3><?php echo __( 'Format', 'hpwallart' ); ?></h3>
                <p><?php echo __( 'Select one of the formats that we offer:', 'hpwallart' ); ?></p>-->
                <table border="0" bordercolor="#FFFFFF" cellpadding="0" cellspacing="0" id="ejemplos1" style="border-collapse:separate; border-spacing:5px;">
                <tr>
				<?php
				$i = 0;
				$thumb = '';
				
				//formatC($PRODUCTS);
				
				foreach($PRODUCTS as $k => $product)
				{
					if(get_option('use_'.$product->type) == '1'){
					if($product->type == 'WA_WP')
					{
						$product->type = 'PSTR';
					}
					//conditions: product exist in real time && if objects are disabled, app must use backgrounds 
					if(in_array($product->type, $apps))
					{
					
					if($use_backgrounds != 1 && $use_objects != 1)
					{
						
					}
					elseif($use_objects != 1 && $presets[$product->type]['use_backgrounds_step'] != 1)
					{
						continue;
					}
						
						if($i % 4 == 0) echo '<tr class="active_app">';
						
						if($product->thumbnail != '')
						{
							$thumb = $product->thumbnail;	
						}
						else
						{
							$thumb = plugins_url('hpwallart/images/default.jpg');	
						}
						
						if($product->icon != 'https://hpwallart.com/images/settings_v4/products/deafult_image.png')
						{
							$icon = $product->icon;	
						}
						else
						{
							$icon = plugins_url('hpwallart/images/icon_default.png');	
						}
						
						// if(get_option('use_'.$product->type) == '1')
						// {
						?>
                        <td width="25%" valign="top" style="height:auto; text-align:left;">
                            <input type="radio" name="app" value="<?php echo $k; ?>" id="opens<?php echo $k; ?>" />
                            <label for="opens<?php echo $k; ?>" id="open<?php echo $k; ?>" style="height:100%; width:100%;" class="open">
                                <div class="interna"><img style="max-height:20em; width:30%; border-radius:.5em;" src="<?php echo $icon; ?>" /></div>
                            	<div class="subtitulo"><?php echo ucfirst($product->post_title); ?></div>
                        	</label>
                            
                            <div id="content<?php echo $k; ?>" class="content-div">
                            
                            
                          <!--   VARIATIONS--> 
                            <?php
                            if(count($product->variations))
                            {
                                foreach($product->variations as $s => $v)
                                {
                                	if($product->type == 'CPT' || $product->type == 'BRL' || $product->type == 'VAN' || $product->type == 'WSEE' || 
                                		$product->type == 'MSEE' || $product->type == 'CSEE'){
                               			$presets[$product->type]['custom_enabled'] = 1;
                                	}
                                ?>  <!-- /Robosoft 2018-03-14::Enable and disable a custom sizes/ -->  
                                    <input type="radio" name="radio" value="<?php echo $v['variation_id']; ?>" id="radio<?php echo $v['variation_id']; ?>" onclick="setTipo('<?php echo $v['variation_id']; ?>', '<?php echo $product->type;?>', '<?php echo $product->type;?>', '<?php echo $factor; ?>', '<?php echo $divisor; ?>', '<?php echo $unit; ?>', '<?php echo $presets[$product->type]['presets_enabled']; ?>', '<?php echo $presets[$product->type]['custom_enabled']; ?>', '<?php echo $provider[$product->type]['backgrounds']; ?>', '<?php echo $provider[$product->type]['objects']; ?>', '<?php echo $k; ?>', '<?php echo $presets[$product->type]['use_backgrounds_step']; ?>'); setVariation('<?php echo $v['attributes']['attribute_pa_media_substrate']; ?>', '<?php echo str_replace(array("\r", "\n"), '', strip_tags($v['variation_description'])); ?>', '<?php echo $v['display_price']; ?>', '<?php echo get_option('woocommerce_currency'); ?>', '<?php echo $square; ?>');"  />
                                	<label for="radio<?php echo $v['variation_id']; ?>" style="height:100%;"><?php echo ucwords($v['attributes']['attribute_pa_media_substrate']); ?>: <?php echo strip_tags(wc_price($v['display_price'])).' '.get_option('woocommerce_currency').'/'.$square; ?></label>
                                	<!--  /Robosoft End/  -->
								<?php
                                }
                            }
                            ?>
                            </div>
                        </td>
						<?php
                        if($i+5 % 4 == 0) echo '</tr>';
                        $i++;
                        }
					}
				}
				?>
                </tr>
                </table>
            </div>

        </fieldset>
        </form>
    </div>
    
    <div class="clear"></div>
    <script><?php if($_SESSION['basket']['type'] != '') {?>calculate('<?php echo $_SESSION['basket']['ancho']; ?>', '<?php echo $_SESSION['basket']['alto']; ?>', '<?php echo $factor; ?>', '<?php echo $divisor; ?>', '<?php echo $unit; ?>');<?php }?></script>