<?php
	/**
		 @contact   HP WallArt Barcelona Team (abad@hp.com)
	 
		 @version   1.0
		 @date Feb 1 2015
	 
	*   (c) Copyright 2018 Hewlett-Packard Development Company L.P
	*   All rights reserved. Copying or other reproduction of this
	*   program except for archival purposes is prohibited without
	*   written consent of HP Inc.
	*
	*   HP / GSB / LFPro
	*/

	//PAGINACION
	function getPagination ($PARAM)
	{
		// Número total de páginas que se presentarán de $resultsPerPage en $resultsPerPage
		$DATA['NUM_OBJS_TOTAL'] = $PARAM['num_objs_total'];
		
		$NUM_PAGINAS = ceil($PARAM['num_objs_total'] / $PARAM['searchResultsPerPage']);
		$DATA['NUM_PAGINAS'] = ($NUM_PAGINAS-1) * $PARAM['searchResultsPerPage'];
		
		// Nos situamos en la página actual
		$PAGINA_ACTUAL = floor($PARAM['searchFromResult'] / $PARAM['searchResultsPerPage']) + 1;
		$DATA['ACTUAL_PAGE'] = $PAGINA_ACTUAL;
		
		// Obtenemos paginacion de paginas en la que nos encontramos.
		// Si $PAGINA_ACTUAL es menor o igual que $paginationPerPage,
		// estamos en la primera pagina de paginaciones
		$actual_page_pagination = ceil($PAGINA_ACTUAL / $PARAM["searchPaginationPerPage"]);
		
		
		// Obtenemos los numeros a mostrar y $PARAM["searchFromDate"] de cada enlace
		for ($i = ($PARAM["searchPaginationPerPage"] * ($actual_page_pagination-1) ) + 1; $i <= $PARAM["searchPaginationPerPage"] * ($actual_page_pagination); $i++) 
		{
			// Comprobamos que no nos pasemos de $NUM_PAGINAS
			if ($i <= $NUM_PAGINAS)
			{
				$DATA['PAGES'][$i] = $PARAM['searchResultsPerPage'] * ($i - 1);
			}
		}
				
		// Obtenemos $DATA['PREV_PAGE_PAGINATION']
		if ($actual_page_pagination > 1)
		{
			$DATA['PREV_PAGE_PAGINATION'] = ($PARAM['searchResultsPerPage'] * ($PARAM["searchPaginationPerPage"] * ($actual_page_pagination-1))) - ($PARAM['searchResultsPerPage']);
		}
		
		// Obtenemos $DATA['NEXT_PAGE_PAGINATION']
		$DATA['NEXT_PAGE_PAGINATION'] = ($PARAM['searchResultsPerPage'] * ($PARAM["searchPaginationPerPage"] * $actual_page_pagination));
		// Comprabamos que no nos hayamos pasado
		if ($DATA['NEXT_PAGE_PAGINATION'] > $PARAM['searchResultsPerPage'] * $NUM_PAGINAS)
		{
			unset($DATA['NEXT_PAGE_PAGINATION']);
		}
		
		// Obtenemos enlace a anterior
		// Si vemos que no tenemos enlace al anterior, vemos
		// si lo podemos obtener de PREV_PAGE_PAGINATION
		$DATA['PREV'] = $DATA['PAGES'][$PAGINA_ACTUAL-1];
		if (strlen($DATA['PREV']) == 0)
		{
			$DATA['PREV'] = $DATA['PREV_PAGE_PAGINATION'];
		}
		
		if (strlen($DATA['PREV']) == 0)
		{
			unset($DATA['PREV']);
		}
		
		// Obtenemos enlace a siguiente
		// Si vemos que no tenemos enlace al siguiente, vemos
		// si lo podemos obtener de NEXT_PAGE_PAGINATION
		$DATA['NEXT'] = $DATA['PAGES'][$PAGINA_ACTUAL+1];
		if (strlen($DATA['NEXT']) == 0)
		{
			$DATA['NEXT'] = $DATA['NEXT_PAGE_PAGINATION'];
		}
		
		if (strlen($DATA['NEXT']) == 0)
		{ 
			unset($DATA['NEXT']);
		}
			
		return $DATA;
	}

	function is_https(){
		if ( (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443)
			return true;
		else
			return false;
	}
	
	//addToCart
	if(isset($_POST['action']))
	{
		switch($_POST['action'])
		{
			case 'add':
			{
				
				$encontradoFondo = false;
				$encontradoObjeto = false;
				//1. buscamos si los contenidos pasados existen en el array
	
				if(isset($_SESSION['basket']))
				{
					if($_SESSION['basket']['paso'] == '2' && count($_SESSION['basket']['fondos']))
					{
						foreach($_SESSION['basket']['fondos'] as $key => $value)
						{
							if($value['id'] == $_POST['id'])
							{
								$encontradoFondo = true;
							}
						}
					}
					
					if($_SESSION['basket']['paso'] == '3' && count($_SESSION['basket']['objetos']))
					{
						foreach($_SESSION['basket']['objetos'] as $key => $value)
						{
							if($value['id'] == $_POST['id'])
							{
								$encontradoObjeto = true;
							}
						}
					}
				}
				
				if($_SESSION['basket']['paso'] == '2' && $encontradoFondo == false && $_POST['id'] != '') // && count($_SESSION['basket']['fondos']) <= 4
				{
					// $array = array('tipo' => $_POST['tipo'], 'id' => $_POST['id'], 'objeto_path' => $_POST['objeto_path'], 'provider_backgrounds' => $_POST['provider_backgrounds']);
					$array = array('tipo' => $_POST['tipo'], 'id' => $_POST['id'], 'matadata' => array('recolorable' => $_POST['matadata']), 'objeto_path' => $_POST['objeto_path'], 'provider_backgrounds' => $_POST['provider_backgrounds']);
					
					//3. añadimos el elemento
					$_SESSION['basket']['fondos'][] = $array;
				}
				
				if($_SESSION['basket']['paso'] == '3' && $encontradoObjeto == false && $_POST['id'] != '') // && count($_SESSION['basket']['fondos']) <= 4
				{
					$array = array('tipo' => $_POST['tipo'], 'id' => $_POST['id'], 'objeto_path' => $_POST['objeto_path'], 'provider_objects' => $_POST['provider_objects']);
					//3. añadimos el elemento
					$_SESSION['basket']['objetos'][] = $array;
				}
			} break;
			
			case 'del':
			{
				//1. recorremos el array en busca del elemento
				if(count($_SESSION['basket']['fondos']))
				{
					foreach($_SESSION['basket']['fondos'] as $key => $value)
					{
						if($value['id'] == $_POST['id'])
						{
							array_splice($_SESSION['basket']['fondos'], $key, 1);
						}
					}
				}
				
				//2. recorremos el array en busca del objeto
				if(count($_SESSION['basket']['objetos']))
				{
					foreach($_SESSION['basket']['objetos'] as $key => $value)
					{
						if($value['id'] == $_POST['id'])
						{
							array_splice($_SESSION['basket']['objetos'], $key, 1);
						}
					}
				}
			} break;
		
			case 'medidas':
			{
				//print_r($_POST);
				//exit();
				foreach($_POST as $key => $value)
				{
					$_SESSION['basket']['medidas'][$key] = $value;
				}
				
				//comprobacion de valores para pasar al paso 1
				if($_POST['proyecto'] == '')
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Nombre del proyecto</strong> es obligatorio";
				}
				elseif($_POST['ancho'] == '')
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Ancho de la pared</strong> es obligatorio";
				}
				elseif(!is_numeric($_POST['ancho']))
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Ancho de la pared</strong> debe ser numérico";
				}
				elseif($_POST['alto'] == '')
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Altura de la pared</strong> es obligatorio";
				}
				elseif(!is_numeric($_POST['alto']))
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Altura de la pared</strong> debe ser numérico";
				}
				/*elseif($_POST['puerta'] == '')
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Posición de la puerta</strong> es obligatorio";
				}
				elseif($_POST['ventana'] == '')
				{
					$_SESSION['resultado']['status'] = 'medidas';
					$_SESSION['resultado']['respuesta'] = "El campo <strong>Posición de la ventana</strong> es obligatorio";
				}*/
				else
				{
					$_SESSION['resultado']['status'] = '';
					$_SESSION['resultado']['respuesta']= "";
					
					if(!$_SESSION['user'])
					{
						$_SESSION['paso'] = '1';
					}
					else
					{
						$_SESSION['paso'] = '5';
					}
				}
				
			} break;

			case 'update': 
			{
				//en este caso substituimos el elemento almacenado siempre por el nuevo, es para planes con un solo curso elegible
				
				//1. Vaciamos array de basket
				unset($_SESSION['basket']);
				
				//2. hallamos el total de elementos
				$array = array('plan' => $_POST['plan'], 'programa' => $_POST['programa'], 'curso' => $_POST['curso'], 'accion' => $_POST['accion'], 'guarderia' => $_POST['guarderiaDays'], 'autobus' => $_POST['autobusOk']);
				
				//3. añadimos el elemento
				$_SESSION['basket'][] = $array;
			} break;
		
			case 'up':
			{
				//1. recorremos el array en busca del elemento
				foreach($_SESSION['basket'] as $key => $value)
				{
					if($value['accion'] == $_POST['accion'])
					{
						$index = $key;
					}
				}
				
				//2. ordenamos el array
				if($index > 0 && $index <count($_SESSION['basket'])) 
				{
					$b = array_slice($_SESSION['basket'], 0, $index-1, true);
					$b[] = $_SESSION['basket'][$index];
					$b[] = $_SESSION['basket'][$index-1];
					$b += array_slice($_SESSION['basket'], $index+1, count($_SESSION['basket']), true);
					
					$_SESSION['basket'] = $b;
				}
			} break;
		
			case 'down': 
			{
				//1. recorremos el array en busca del elemento
				foreach($_SESSION['basket'] as $key => $value)
				{
					if($value['accion'] == $_POST['accion'])
					{
						$index = $key;
					}
				}
				
				//2. ordenamos el array
				if(count($_SESSION['basket'])-1 > $index) 
				{
					$b = array_slice($_SESSION['basket'], 0, $index, true);
					$b[] = $_SESSION['basket'][$index+1];
					$b[] = $_SESSION['basket'][$index];
					$b += array_slice($_SESSION['basket'], $index+2, count($_SESSION['basket']), true);
					
					$_SESSION['basket'] = $b;
				} 
							
			} break;
		}
	}
	
	//Change paso and add parameters to session
	if(isset($_GET['paso']))
	{
		foreach($_GET as $k => $v)
		{
			$_SESSION['basket'][$k] = $v;	
		}
		
		//if not use backgrouns neither objects
		if($use_backgrounds != 1 && $use_objects != 1)
		{
			$_SESSION['basket']['paso'] = '1';
		}
	}
	
	//destroy session
	if(isset($_GET['destroy']))
	{
		unset($_SESSION["basket"]);
		unset($_SESSION);
		session_destroy();
		$_SESSION['basket']['paso'] = '1';	
	}

	//for programmers only, var dump an array
	function formatC($var, $oculto = NULL, $nombre = NULL)
	{
		if($oculto)
		{
			echo '<!--';
		}
		echo '<pre style="text-align:left; font-size:10px; ">';
		echo $nombre.'<br />';
		print_r($var);
		echo '</pre>';
		if($oculto)
		{
			echo '-->';
		}
	}
	
	//array of languages for Fotolia Categories
	switch(strtoupper(get_bloginfo('language')))
	{
		case 'FR-FR': $LANG_FOTOLIA = '1'; break;
		case 'EN-US': $LANG_FOTOLIA = '2'; break;
		case 'EN-EN': $LANG_FOTOLIA = '3'; break;
		case 'DE-DE': $LANG_FOTOLIA = '4'; break;
		case 'ES-ES': $LANG_FOTOLIA = '5'; break;
		case 'IT-IT': $LANG_FOTOLIA = '6'; break;
		case 'PT-PT': $LANG_FOTOLIA = '7'; break;
		case 'PT-BR': $LANG_FOTOLIA = '8'; break;
		case 'JA': $LANG_FOTOLIA = '9'; break;
		case 'PL-PL': $LANG_FOTOLIA = '11'; break;
		case 'RU-RU': $LANG_FOTOLIA = '12'; break;
		case 'ZH-CN': $LANG_FOTOLIA = '13'; break;
		case 'TR-TR': $LANG_FOTOLIA = '14'; break;
		case 'KO-KR': $LANG_FOTOLIA = '15'; break;
		default: $LANG_FOTOLIA = '3'; break;
	}
?>