<?php
	/**
		 @contact   HP WallArt Barcelona Team (abad@hp.com)
	 
		 @version   1.0
		 @date Feb 1 2015
	 
	*   (c) Copyright 2015 Hewlett-Packard Development Company L.P
	*   All rights reserved. Copying or other reproduction of this
	*   program except for archival purposes is prohibited without
	*   written consent of HP Inc.
	*
	*   HP / GSB / LFPro
	*/

//helper function for comfortably performing api calls
function patternDesignApiCall($method, $params = array(), $jsonResult = true, $post = false, $apiKey = NULL, $hmacKey = NULL) 
{
//    $apiKey = $config['api_key'];
//    $hmacKey = $config['hmac_key'];


    $timestamp = gmdate("Y-m-d")."T".gmdate("H:i")."Z";
    $nonce = md5(time() + rand());

    $stringToSign = $apiKey . $timestamp . $nonce;
    $signature = hash_hmac("sha256", $stringToSign, $hmacKey);

    $authenticationParams = array("nonce" => $nonce, "timestamp" => $timestamp, "signature" => $signature);

    $urlParams = http_build_query(array_merge($authenticationParams, $params));
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, "http://patterndesigns.com/api/rest/1.0/" . $apiKey . "/" . $method . "/?" . $urlParams);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	
	//echo "http://patterndesigns.com/api/rest/1.0/" . $apiKey . "/" . $method . "/?" . $urlParams;

    if ($post) {
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, '');
    }

    $result = curl_exec($curl);

    $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

    if(curl_errno($curl)) {
        error_log("Pattern Design API call $method (" . var_export($params, true) . ") returned curl error: " . curl_error($curl));
    } else if ($httpCode != 200) {
        error_log("Pattern Design API call $method (" . var_export($params, true) . ") resulted in http code $httpCode with response: $result");
    }

    curl_close($curl);

    if ($jsonResult) {
        return json_decode($result, true);
    } else {
        return $result;
    }
}

//$par = array();
//$clientToken = array();
//$clientToken = patternDesignApiCall("user/getAccessToken", $par , '', '', $config['api_key'], $config['hmac_key']);
//$clientToken = json_decode($clientToken, true);
//echo $clientToken['token'];
//formatC($clientToken);
	require_once(dirname(__FILE__).'/navigation.php');
?>

	<!--Lateral con boton de pasar de paso + carrito compra-->
    <?php
	if($_GET['searchresults'] == '1')
	{
	?>
    <div id="lateral">
    	<div class="fijado">
            <?php include(dirname(__FILE__).'/sidebar.inc.php'); ?>
        </div>
	</div>
	<?php
	}
	?>

	<?php
	if(!$_GET['searchresults'] && !$_GET['k'])
	{
		$galleries = array();
		$galleries = patternDesignApiCall('pattern/getCategories', array("includeSubcategories" => 'true'), true, false, $config['api_key'], $config['hmac_key']);
		//formatC($galleries);
	?>
    <!--<h1 style="padding-bottom:0;"><?php echo __( 'Search for backgrounds', 'hpwallart' ); ?></h1>
	buscador general como el de airbnb-->
	<div id="cat1_id" style="width:100%;">
    <form id="buscadorFondos" class="" action="" method="get" enctype="multipart/form-data" style="width:100%; background-size:100%;">
        <fieldset>
        <div style="height:600px; background-color:rgba(33,20,21,0.4); text-align:center;">
        <p style="font-size:2em; line-height:2em; margin:4em 0 0 0; color:white;"><?php echo __( 'USE THE SEARCH ENGINE TO FIND THE OBJECTS YOU WANT', 'hpwallart' ); ?></p>
        <p style="font-size:1.2em; line-height:1em; margin:3em 0; color:white;"><?php echo __( 'Search over 13 million images in our search engine.', 'hpwallart' ); ?></p>
        <input type="text" name="k" id="k" value="<?php echo $_GET['k']; ?>" style="width:38%; margin-left:0.5em;" placeholder="<?php echo __( 'Enter the word to search', 'hpwallart' ); ?>"/>
		<div class="select">
        <select name="category" id="category">
            <option value=""><?php echo __( 'Category', 'hpwallart' ); ?></option>
			<?php
            foreach($galleries['categories'] as $key => $value) 
            {
            ?>
                <option value="<?php echo $value['id'] ?>"><?php echo ($value['title']);?></option>
            <?php
            }
            ?>
        </select>
        </div>
        <input class="enviar" type="submit" value="<?php echo __( 'Search', 'hpwallart' ); ?>" />
        <input type="hidden" name="searchresults" id="searchresults" value="1" />
        <input type="hidden" name="size" id="size" value="xl" />
        <input type="hidden" name="language" id="language" value="es" />
        </div>
        </fieldset>
    </form>

	</div>

	<?php
	}
	?>
	<!--Imágenes de uns sugerencia o del buscador-->
	<?php
	if($_GET['searchresults'])
	{
		if(!$_GET['vectors'] && !$_GET['illustrations'] && !$_GET['photos']) $all = 1; else $all = 0;


		$results = array();
		$results = array(
				'categoryIds' => $_GET['category'],
				'offset' => $_GET['limit'],
				'limit' => $GLOBALS['nNot'],		//cambiar cuando abramos la web
				'text' => $_GET['k'],
				'useSecureUrls' => 'true',
				'language' => $_GET['language'],
				'resultFields' => 'id,title,thumbnails.gallery,thumbnails.xlarge, metadata.recolorable'
		);
		$products = patternDesignApiCall('pattern/search', $results, true, false, $config['api_key'], $config['hmac_key']);
		
		//formatC($products);
		$galleries = array();
		$galleries = patternDesignApiCall('pattern/getCategories', array("includeSubcategories" => 'true'), true, false, $config['api_key'], $config['hmac_key'], $results);
		//formatC($galleries);
	?>
	<div id="cat2_id">
        <!--buscador simplficado-->
        <form id="buscadorFondos" class="sinFondo" action="" method="get" enctype="multipart/form-data">
            <fieldset>
            <div>
            <input type="text" name="k" id="k" value="<?php echo $_GET['k']; ?>" placeholder="<?php echo __( 'Enter the word to search', 'hpwallart' ); ?>" style="width:23.4%;" />
            
			<div class="select">
            <select name="category" id="category">
                <option value=""><?php echo __( 'Category', 'hpwallart' ); ?></option>
                <?php
                foreach($galleries['categories'] as $key => $value) 
                {
                ?>
                    <option value="<?php echo $value['id'] ?>" <?php if ($value['id'] == $_GET['category']) echo 'selected'; ?>><?php echo ($value['title']);?></option>
                <?php
                }
                ?>
            </select>
			</div>
            
            <input class="enviar" type="submit" value="<?php echo __( 'Search', 'hpwallart' ); ?>" />
            <input type="hidden" name="searchresults" id="searchresults" value="1" />
            <input type="hidden" name="size" id="size" value="xl" />
            <input type="hidden" name="language" id="language" value="5" />
            </div>
            </fieldset>
        </form>

        <!--<h2 style="display:block; text-align:left; ">
        	<a href="/es/proceso" title="">fondos</a><?php echo $categoria ?>
        </h2>-->
        <?php
		if(count($products) > 1)
		{
		?>
			<?php 
			if($GLOBALS['active_tooltip'] == '1')
			{
			?>
			<script type="text/javascript" src="<?php echo plugins_url( '../js/jquery.ezpz_tooltip.js', __FILE__ ); ?>"></script>
        
            <style type="text/css" media="screen"> 
                h3 { margin-top: 20px; } 
                .tooltip-target { display: block; padding: 10px; background-color: #EEE; text-align: center; } 
                #cat2_id .tooltip-content { display: none; /* required */ position: absolute; /* required */ width: 400px; height:400px; padding: 0; text-align: center; color: black;  overflow:initial;} 
                #cat2_id .tooltip-content img { width:auto;} 
                #fancy-content-1 { border: none; background:#ececec; border-radius:1em; width: 450px; height: 450px; } 
            </style>
            <?php
			}
			?>
            
            <table cellpadding="0" cellspacing="0" width="100%" id="miniaturas">
            <?php	
            $i = 0;
            foreach($products['patterns'] as $key => $value) 
            {
                // iterating only over numeric keys and silently skip other keys
                if (is_numeric($key)) 
                {
                    if($i % 4 == 0) echo '<tr style="height:250px;">';
            ?>        
                    <td valign="top" align="center">
                        <table height="" width="100%" border="0" cellpadding="0" cellspacing="0"> 	
                        <tr>
                            <td valign="top" align="center">
                                <div class="fancy-tooltip-target tooltip-target" id="fancy-target-<?php echo $value['id'] ?>" style="background:url(<?php echo $value['thumbnails']['gallery']['url'];?>) no-repeat center;"></div>
                                <div class="fancy-tooltip-content tooltip-content" id="fancy-content-<?php echo $value['id'] ?>" style="display: none; z-index:1000000; height:<?php echo $value['thumbnail_400_height']+10; ?>px;">
                                    <img src="<?php echo $value['thumbnails']['xlarge']['url'];?>" alt="" />
                                    <br />
                                    <?php echo $value['id'] ?>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td valign="bottom" align="center">
                            <?php 
                            if($_SESSION['basket']['objetos'])
                            {
                                $Fondo = false;
                                foreach($_SESSION['basket']['objetos'] as $array)
                                {
                                    if(in_array($value['id'], $array))
                                    {
                                        $Fondo = true;
                                    }
                                }	
                            }
                                                    
                            if($Fondo)
                            {
                            ?>
                                <span onclick="return false;" class="seleccionado"><button><i class="icon-check"></i> <?php echo __( 'Selected', 'hpwallart' ); ?></button></span>
                            <?php 
                            }
                            else
                            {
                            ?>
                                <form id="" class="" action="" method="POST" enctype="multipart/form-data">
                                <a href="javascript: this.form.submit();" title="">
                                    <button onclick="<?php if(count($_SESSION['basket']['objetos']) >= $GLOBALS['nos']) { ?>alert('<?php echo __( 'The maximum number of objects is limited. You must remove at least one object of the side.', 'hpwallart' ); ?>'); return false; <?php }?>"><i class="icon-check-empty"></i> <?php echo __( 'Select', 'hpwallart' ); ?></button>
                                </a>
                                <input type="hidden" name="searchresults" id="searchresults" value="1" />
                                <input type="hidden" name="tipo" id="tipo" value="1" />
                                <input type="hidden" name="paso" id="paso" value="3" />
                                <input type="hidden" name="objeto_path" id="objeto_path" value="<?php echo $value['thumbnails']['xlarge']['url'] ?>" />
                                <input type="hidden" name="provider_objects" id="provider_objects" value="3" />
                                <input type="hidden" name="id" id="id" value="<?php echo $value['id'] ?>" />
                                <input type="hidden" name="action" id="action" value="add" />
                                </form>
                            <?php 
                            }
                            ?>
                            </td>
                        </tr>
                            <?php //echo $value['id']; ?>
                            <?php //echo $value['width']." x ".$value['height'].' pixeles'; ?>
                        </table>
                    </td>
            <?php        
                    if($i+5 % 4 == 0) echo '</tr>';
                    $i++;
                }
            }
            ?>
            </table>

			<?php 
			if($GLOBALS['active_tooltip'] == '1')
			{
			?>
			<script type="text/javascript" charset="utf-8">
            jQuery(document).ready(function($){ 
                $(".tooltip-target").ezpz_tooltip({
                  contentPosition: 'belowFollow',
                  //offset: -100
                }); 
            });
            </script>
        <?php
			}
		}
		else
		{
		 	echo __( 'No results found', 'hpwallart' );
		}
		?>
	</div>
	<?php
		$TOTAL = $products['totalHits'];
	
		//obtenemos la paginacion
		$PARAMPAG['num_objs_total'] = $TOTAL;
		$PARAMPAG['searchFromResult'] = $_GET['limit'];
		$PARAMPAG['num_objs_parcial'] = $GLOBALS['nNot'];
		$PARAMPAG['searchResultsPerPage'] = $GLOBALS['nNot'];
		$PARAMPAG["searchPaginationPerPage"] = $GLOBALS['nNot'];
		$PARAMPAG["path"] = get_permalink( $post->ID );
	
		$PAGINACION = getPagination($PARAMPAG);
		//formatC($PAGINACION);
		
		if ($PAGINACION[NUM_OBJS_TOTAL] > $PARAMPAG['searchResultsPerPage'])
		{
			include(dirname(__FILE__).'/pagination.inc.php');
		}
	}
	?>