<?php 
	/**
		 @contact   HP WallArt Barcelona Team (abad@hp.com)
	 
		 @version   2.0
		 @date Feb 1 2015
	 
	*   (c) Copyright 2015 Hewlett-Packard Development Company L.P
	*   All rights reserved. Copying or other reproduction of this
	*   program except for archival purposes is prohibited without
	*   written consent of HP Inc.
	*
	*   HP / GSB / LFPro
	*/
	
	
	// if there are many files in your Dropbox it can take some time, so disable the max. execution time
	set_time_limit(0);

	require_once(dirname(__FILE__).'/classes/google-api-php-client-master/examples/templates/base.php');	 

	/************************************************
	  Make an API request on behalf of a user. In
	  this case we need to have a valid OAuth 2.0
	  token for the user, so we need to send them
	  through a login flow. To do this we need some
	  information from our API console project.
	 ************************************************/
	$client = new Google_Client();
	$client->setClientId($client_id);
	$client->setClientSecret($client_secret);
	//$client->setRedirectUri($redirect_uri);
	$client->setRedirectUri('urn:ietf:wg:oauth:2.0:oob');
	$client->addScope("https://www.googleapis.com/auth/drive");

	/************************************************
	  When we create the service here, we pass the
	  client to it. The client then queries the service
	  for the required scopes, and uses that when
	  generating the authentication URL later.
	 ************************************************/
	$dr_service = new Google_Service_Drive($client);
	/************************************************
	  If we're logging out we just need to clear our
	  local access token in this case
	 ************************************************/
	if (isset($_REQUEST['logout'])) {
	  unset($_SESSION['access_token']);
	}
	if (isset($_GET['code'])) {
	  $client->authenticate($_GET['code']);
	  $_SESSION['access_token'] = $client->getAccessToken();
	  $redirect = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	  @header('Location: ' . filter_var($redirect, FILTER_SANITIZE_URL));
	}
	
	if (isset($_SESSION['access_token']) && $_SESSION['access_token']) {
	  $client->setAccessToken($_SESSION['access_token']);
	} else {
	  $authUrl = $client->createAuthUrl();
	}
	/************************************************
	  If we have an access token, we can make
	  requests, else we generate an authentication URL.
	 ************************************************/
	if ($client->getAccessToken()) {
	  $_SESSION['access_token'] = $client->getAccessToken();
	  $dr_results = $dr_service->files->listFiles(array('maxResults' => 10, 'q' => 'title contains "WallArt"'));
	}
	
	echo pageHeader("User Query - Multiple APIs");
	if (strpos($client_id, "googleusercontent") == false) {
	  echo missingClientSecretsWarning();
	  exit;
	}
	
	require_once(dirname(__FILE__).'/navigation.php');
	
?>

<div class="box">
  <div class="request">
<?php 
if (isset($authUrl)) {
  echo "<a class='login' href='" . $authUrl . "'>Connect Me!</a>";
} else {
  echo "<h3>Results Of Drive List:</h3>";
  foreach ($dr_results as $item) {
    echo $item->title, "<br /> \n";
  }

  echo "<h3>Results Of YouTube Likes:</h3>";
} ?>
  </div>
</div>
	<!--Lateral con boton de pasar de paso + carrito compra-->
    <?php
	//try Google Drive Api
	$dr_results = $dr_service->files->listFiles(array('maxResults' => 10));
	
	formatC($dr_results);
	
	
	
	
	if($_GET['searchresults'] == '1')
	{
	?>
    <div id="lateral">
    	<div class="fijado">
            <!--<a class="boton_continuar" href="?paso=3" title="Continuar al PASO 3">Continuar<span>al PASO 3</span></a>
            <a class="boton_empezar" href="?destroy=1" title="Comenzar el proceso de nuevo">Comenzar <span>de nuevo</span></a>-->
            <?php include(dirname(__FILE__).'/sidebar.inc.php'); ?>
        </div>
	</div>
	<?php
	}
	?>

	<?php
	if(!$_GET['searchresults'] && !$_GET['k'])
	{
		//$files = $dropbox->GetFiles("scenes", false);
		//formatC($files);
	?>
    <!--<h1 style="padding-bottom:0;"><?php echo __( 'Search for backgrounds', 'hpwallart' ); ?></h1>
	buscador general como el de airbnb-->
	<div id="cat1_id" style="width:100%;">
    <form id="buscadorFondos" class="" action="" method="get" enctype="multipart/form-data" style="width:100%; background-size:100%;">
        <fieldset>
        <div style="height:600px; background-color:rgba(33,20,21,0.4); text-align:center;">
        <p style="font-size:2em; line-height:2em; margin:4em 0 0 0; color:white;"><?php echo __( 'USE THE SEARCH ENGINE TO FIND THE IMAGES YOU WANT', 'hpwallart' ); ?></p>
        <p style="font-size:1.2em; line-height:1em; margin:3em 0; color:white;"><?php echo __( 'Search over 13 million images in our search engine.', 'hpwallart' ); ?></p>
        <input type="text" name="k" id="k" value="<?php echo $_GET['k']; ?>" style="width:38%; margin-left:0.5em;" placeholder="<?php echo __( 'Enter the word to search', 'hpwallart' ); ?>"/>

        <input class="enviar" type="submit" value="<?php echo __( 'Search', 'hpwallart' ); ?>" />
        <input type="hidden" name="searchresults" id="searchresults" value="1" />
        <input type="hidden" name="size" id="size" value="xl" />
        <input type="hidden" name="language" id="language" value="5" />
        </div>
        </fieldset>
    </form>

	</div>

	<?php
	}
	?>
	<!--Imágenes de uns sugerencia o del buscador-->
	<?php
	if($_GET['searchresults'])
	{
		if($_GET['k'] != '')
		{
			$files = $dropbox->Search("scenes", $_GET['k'], '', false);	
			$results = array_values($files);
		}
		else
		{
			$files = $dropbox->GetFiles("scenes", 1, false);
			$results = array_values($files);
		}
		//formatC($results);
	?>
	<div id="cat2_id">
        <!--buscador simplficado-->
        <form id="buscadorFondos" class="sinFondo" action="" method="get" enctype="multipart/form-data">
            <fieldset>
            <div>
            <input type="text" name="k" id="k" value="<?php echo $_GET['k']; ?>" placeholder="<?php echo __( 'Enter the word to search', 'hpwallart' ); ?>" style="width:23.4%;" />
            
            
            <input class="enviar" type="submit" value="<?php echo __( 'Search', 'hpwallart' ); ?>" />
            <input type="hidden" name="searchresults" id="searchresults" value="1" />
            <input type="hidden" name="size" id="size" value="xl" />
            <input type="hidden" name="language" id="language" value="5" />
            </div>
            </fieldset>
        </form>

        <!--<h2 style="display:block; text-align:left; ">
        	<a href="/es/proceso" title="">fondos</a><?php echo $categoria ?>
        </h2>-->
        <?php
		if(count($results) >= 1)
		{
		?>
			<?php 
			if($GLOBALS['active_tooltip'] == '1')
			{
			?>
			<script type="text/javascript" src="<?php echo plugins_url( '../js/jquery.ezpz_tooltip.js', __FILE__ ); ?>"></script>
        
            <style type="text/css" media="screen"> 
                h3 { margin-top: 20px; } 
                .tooltip-target { display: block; padding: 10px; background-color: #EEE; text-align: center; } 
                #cat2_id .tooltip-content { display: none; /* required */ position: absolute; /* required */ width: 400px; height:400px; padding: 0; text-align: center; color: black;  overflow:initial;} 
                #cat2_id .tooltip-content img { width:auto;} 
                #fancy-content-1 { border: none; background:#ececec; border-radius:1em; width: 450px; height: 450px; } 
            </style>
            <?php
			}
			?>
            
            <table cellpadding="0" cellspacing="0" width="100%" id="miniaturas">
            <?php	
            $i = 0;
            foreach($results as $key => $value) 
            {
                // iterating only over numeric keys and silently skip other keys
                if ($value->is_dir != '1') 
                {
                    if($i % 4 == 0) echo '<tr style="height:250px;">';
					
					//$img_data = base64_encode($dropbox->GetThumbnail($value->path, 'l'));
					//'data:image/jpeg;base64,<?php echo $img_data; 
					
					$img_url = $dropbox->GetLink($value->path, false, false);
            ?>        
                    <td valign="top" align="center" width="25%">
                        <table height="" width="100%" border="0" cellpadding="0" cellspacing="0"> 	
                        <tr>
                            <td valign="top" align="center">
                                <div class="fancy-tooltip-target tooltip-target" id="fancy-target-<?php echo $value->rev ?>" style="background:url(<?php echo $img_url ?>) no-repeat center; background-size:contain;"></div>
								<?php 
                                if($GLOBALS['active_tooltip'] == '1')
                                {
                                ?>
                                <div class="fancy-tooltip-content tooltip-content" id="fancy-content-<?php echo $value->rev ?>" style="display: none; z-index:1000000; height:40px;">
                                    <img src="<?php echo $img_url;?>" alt="" />
                                    <br />
                                    <?php echo $value->rev ?>
                                </div>
                                <?php
								}
								?>
                            </td>
                        </tr>
                        <tr>
                            <td valign="bottom" align="center">
                            <?php 
                            if($_SESSION['basket']['fondos'])
                            {
                                $Fondo = false;
                                foreach($_SESSION['basket']['fondos'] as $array)
                                {
                                    if(in_array($value->rev, $array))
                                    {
                                        $Fondo = true;
                                    }
                                }	
                            }
                                                    
                            if($Fondo)
                            {
                            ?>
                                <span onclick="return false;" class="seleccionado"><button><i class="icon-check"></i> <?php echo __( 'Selected', 'hpwallart' ); ?></button></span>
                            <?php 
                            }
                            else
                            {
                            ?>
                                <form id="" class="" action="" method="POST" enctype="multipart/form-data">
                                <a href="javascript: this.form.submit();" title="">
                                    <button onclick="<?php if(count($_SESSION['basket']['fondos']) >= $GLOBALS['nos']) { ?>alert('<?php echo __( 'The maximum number of backgrounds is limited. You must remove at least one photo of the side.', 'hpwallart' ); ?>'); return false; <?php }?>"><i class="icon-check-empty"></i> <?php echo __( 'Select', 'hpwallart' ); ?></button>
                                </a>
                                <input type="hidden" name="tipo" id="tipo" value="1" />
                                <input type="hidden" name="paso" id="paso" value="3" />
                                <input type="hidden" name="objeto_path" id="objeto_path" value="<?php echo $img_url ?>" />
                                <input type="hidden" name="id" id="id" value="<?php echo $value->rev ?>" />
                                <input type="hidden" name="action" id="action" value="add" />
                                </form>
                            <?php 
                            }
                            ?>
                            </td>
                        </tr>
                            <?php //echo $value['id']; ?>
                            <?php //echo $value['width']." x ".$value['height'].' pixeles'; ?>
                        </table>
                    </td>
            <?php        
                    if($i+5 % 4 == 0) echo '</tr>';
                    $i++;
                }
            }
            ?>
            </table>

			<?php 
			if($GLOBALS['active_tooltip'] == '1')
			{
			?>
			<script type="text/javascript" charset="utf-8">
            jQuery(document).ready(function($){ 
                $(".tooltip-target").ezpz_tooltip({
                  contentPosition: 'belowFollow',
                  //offset: -100
                }); 
            });
            </script>
        <?php
			}
		}
		else
		{
		 	echo __( 'No results found', 'hpwallart' );
		}
		?>
	</div>
	<?php
		$TOTAL = $results['nb_results'];
	
		//obtenemos la paginacion
		$PARAMPAG['num_objs_total'] = $TOTAL;
		$PARAMPAG['searchFromResult'] = $_GET['limit'];
		$PARAMPAG['num_objs_parcial'] = $GLOBALS['nNot'];
		$PARAMPAG['searchResultsPerPage'] = $GLOBALS['nNot'];
		$PARAMPAG["searchPaginationPerPage"] = $GLOBALS['nNot'];
		$PARAMPAG["path"] = get_permalink( $post->ID );
	
		$PAGINACION = getPagination($PARAMPAG);
		//formatC($PAGINACION);
		
		if ($PAGINACION[NUM_OBJS_TOTAL] > $PARAMPAG['searchResultsPerPage'])
		{
			include(dirname(__FILE__).'/pagination.inc.php');
		}
	}
	?>	