<?php
	/**
		 @contact   HP WallArt Barcelona Team (abad@hp.com)
	 
		 @version   1.0
		 @date Feb 1 2015
	 
	*   (c) Copyright 2015 Hewlett-Packard Development Company L.P
	*   All rights reserved. Copying or other reproduction of this
	*   program except for archival purposes is prohibited without
	*   written consent of HP Inc.
	*
	*   HP / GSB / LFPro
	*/


//helper function for comfortably performing api calls
function patternDesignApiCall($method, $params = array(), $jsonResult = true, $post = false, $apiKey = NULL, $hmacKey = NULL) 
{
//    $apiKey = $config['api_key'];
//    $hmacKey = $config['hmac_key'];

    $timestamp = gmdate("Y-m-d")."T".gmdate("H:i")."Z";
    $nonce = md5(time() + rand());

    $stringToSign = $apiKey . $timestamp . $nonce;
    $signature = hash_hmac("sha256", $stringToSign, $hmacKey);

    $authenticationParams = array("nonce" => $nonce, "timestamp" => $timestamp, "signature" => $signature);

    $urlParams = http_build_query(array_merge($authenticationParams, $params));
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, "http://patterndesigns.com/api/rest/1.0/" . $apiKey . "/" . $method . "/?" . $urlParams);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	
	echo "http://patterndesigns.com/api/rest/1.0/" . $apiKey . "/" . $method . "/?" . $urlParams;

    if ($post) {
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, '');
    }

    $result = curl_exec($curl);

    $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

    if(curl_errno($curl)) {
        error_log("Pattern Design API call $method (" . var_export($params, true) . ") returned curl error: " . curl_error($curl));
    } else if ($httpCode != 200) {
        error_log("Pattern Design API call $method (" . var_export($params, true) . ") resulted in http code $httpCode with response: $result");
    }

    curl_close($curl);

    if ($jsonResult) {
        return json_decode($result, true);
    } else {
        return $result;
    }
}

$par = array();
$clientToken = array();
$clientToken = patternDesignApiCall("user/getAccessToken", $par , '', '', $config['api_key'], $config['hmac_key']);
$clientToken = json_decode($clientToken, true);
//echo $clientToken['token'];
//formatC($clientToken);
?>
    <script type="text/javascript">
        var _patternDesignWidget = _patternDesignWidget || {};
        _patternDesignWidget.accessToken =  '<?php echo $clientToken['token']; ?>';
    </script>
    <script id="patternDesignWidgetScript" src="http://patterndesigns.com/api/js/widget.js" type="text/javascript">
    </script>
    <div id="patternDesignWidgetContainer"></div>

<?php
//Get categories
$categories = patternDesignApiCall('pattern/getCategories', array("includeSubcategories" => 'true'), true, false, $config['api_key'], $config['hmac_key']);
//formatC($categories);

//designId and colors selected by the customer
/*$designId = 527;
$colors = "0000aa,bbbb00,ffaa00,caabff,aaaaff,ff0000";

//download preview image in user selected colors
file_put_contents("d:\\preview.png", patternDesignApiCall('pattern/recolor', array("id" => $designId, "colors" => $colors, "resolution" => "600"), false));

//login to get access token for download
$username = "*your api user name*";
$password = "*your api user password*";
$sessionToken = patternDesignApiCall('user/login',  array("username" => $username, "password" => $password));
$sessionToken = $sessionToken['sessionToken'];

//report the sale
$orderReference="00023424";
$productPriceNet = "29,9";
$sale = patternDesignApiCall('sale/report', array("sessionToken" => $sessionToken, "orderReference" => $orderReference, "designIds" => $designId, "productPriceNet" => $productPriceNet, "productName" => "Canvas"), true, true);


//download the production data
$downloadReference = $sale['downloadReferences'][0];
file_put_contents("d:\\production.png", patternDesignApiCall('sale/download', array("sessionToken" => $sessionToken, "downloadReference" => $downloadReference, "fileType" => "jpg", "resolution" => "3000", "colors" => $colors), false));
*/?>