<?php

/**
 * oauth-php: Example OAuth server
 *
 * Global initialization file for the server, defines some helper
 * functions, required includes, and starts the session.
 *
 * @author Arjan Scherpenisse <arjan@scherpenisse.net>
 *
 * 
 * The MIT License
 * 
 * Copyright (c) 2007-2008 Mediamatic Lab
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Session
 */
//session_set_cookie_params(3600, '/', '.personalizatupared.com');  
//session_name('new_session');
//session_id('factotum1');
session_name('PHPSESSID');
session_start();

/*	echo '<pre>';
	print_r($_SESSION);
	echo '</pre>';
*/
/*
 * Simple 'user management'
 */
define ('USERNAME', 'sysadmin');
define ('PASSWORD', 'sysadmin');
define ('OAUTH_LOG_REQUEST', true);

//define ('USERNAME', $_SESSION['user']['user']);
//define ('PASSWORD', $_SESSION['user']['pass']);
//$_SESSION['authorized'] = true;
//session_write_close();

	if (!empty($_SERVER['HTTPS'])) 
	{
		define ('PROTOCOL_WEB', 'https');
	}
	else
	{
		define ('PROTOCOL_WEB', 'http');
	}

/*
 * Always announce XRDS OAuth discovery
 */
header('X-XRDS-Location: '.plugin_dir_url( __DIR__ ).'oauth/example/server/www/services.xrds');


/*
 * Initialize the database connection
 */
//	$parse_uri = explode( 'wp-content', $_SERVER['SCRIPT_FILENAME'] );
//	require_once( $parse_uri[0] . 'wp-load.php' );
	require_once( $_SERVER['DOCUMENT_ROOT'].'/wp-load.php' );

// apache_request_headers replicement for nginx
if(!function_exists('apache_request_headers')) 
{
	function apache_request_headers() 
	{
		foreach($_SERVER as $key=>$value) 
		{
			$value = str_replace( '\"', '', $value);

        	//error_log($value);

        	if (substr($key,0,5)=="HTTP_") 
			{
				$key=str_replace(" ","-",ucwords(strtolower(str_replace("_"," ",substr($key,5)))));
				$out[$key]=$value;
			}
			else
			{
           		$out[$key]=$value;
			}
		}

		return $out;
  	}
} 

function getAllHeadersJorge()
{
	$retarr = array();
	
	//JORGE
	foreach ($_SERVER AS $key => $value) {
		$key = preg_replace('/^HTTP_/i', '', $key);
		$key = str_replace('REDIRECT_', '', $key);
		$key = str_replace('Redirect-', '', $key);
		$key = str_replace(
				" ",
				"-",
				ucwords(strtolower(str_replace(array("-", "_"), " ", $key)))
			);
		$retarr[$key] = $value;
	}
	ksort($retarr);
	
	return $retarr;
}


$info = parse_url(getenv('DB_DSN'));
($GLOBALS['db_conn'] = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD)) || die(mysql_error());
mysql_select_db(basename(DB_NAME), $GLOBALS['db_conn']) || die(mysql_error());
unset($info);

require_once '../../../library/OAuthServer.php';

/*
 * Initialize OAuth store
 */
require_once '../../../library/OAuthStore.php';
OAuthStore::instance('MySQL', array('conn' => $GLOBALS['db_conn']));

/*
 * Session
 */
//session_start();



/*
 * Template handling
 */
require_once 'smarty/libs/Smarty.class.php';
function session_smarty()
{
	if (!isset($GLOBALS['smarty']))
	{
		$GLOBALS['smarty'] = new Smarty;
		$GLOBALS['smarty']->template_dir = dirname(__FILE__) . '/templates/';
		$GLOBALS['smarty']->compile_dir = dirname(__FILE__) . '/../cache/templates_c';
	}
	
	return $GLOBALS['smarty'];
}

function assert_logged_in()
{
	if (empty($_SESSION['authorized']))
	{
		$uri = $_SERVER['REQUEST_URI'];
		header('Location: '.plugin_dir_url( __DIR__ ).'oauth/example/server/www/logon.php?goto='.urlencode($uri)); //ESTA ES LA BUENA...
		exit();
	}
}

//New function to get the logged in user id from the session.
function get_logged_in()
{
	return $_SESSION['authorized_user_id'];
}

//New function to get the actual project in the session.
function get_project_id()
{
	return $_SESSION['authorized_project_id'];
}

function assert_request_vars()
{
	foreach(func_get_args() as $a)
	{
		if (!isset($_REQUEST[$a]))
		{
			header('HTTP/1.1 400 Bad Request');
			echo 'Bad request.';
			exit;
		}
	}
}

function assert_request_vars_all()
{
	foreach($_REQUEST as $row)
	{
		foreach(func_get_args() as $a)
		{
			if (!isset($row[$a]))
			{
				header('HTTP/1.1 400 Bad Request');
				echo 'Bad request.';
				exit;
			}
		}
	}
}

?>