<?php
//ini_set('display_errors', 1); 
//error_reporting(E_ALL & ~E_NOTICE);


/**
 * oauth-php: Example OAuth server
 *
 * This file implements the OAuth server endpoints. The most basic
 * implementation of an OAuth server.
 *
 * Call with: /oauth/request_token, /oauth/authorize, /oauth/access_token
 *
 * @author Arjan Scherpenisse <arjan@scherpenisse.net>
 *
 * 
 * The MIT License
 * 
 * Copyright (c) 2007-2008 Mediamatic Lab
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */


	require_once '../core/init.php';
	
	//open LOG file
	$filename = 'log.txt';
	$h = fopen($filename, 'a');
	//chmod($filename, 0777);


	$path_info = !empty($_SERVER['PATH_INFO']) ? $_SERVER['PATH_INFO'] : (!empty($_SERVER['ORIG_PATH_INFO']) ? $_SERVER['ORIG_PATH_INFO'] : '');


	$server = new OAuthServer();

	switch($path_info)
	{
		case '/request_token':
		{
			$headers = getAllHeadersJorge();
			
			fwrite($h, "\n\n\n\r**************************************************************************************\n");
			fwrite($h, "\r****** Date time: ".(date('Y-m-d H:i:s'))." ******\n");
			fwrite($h, "\r****** Logging incoming headers of POST hitting /request_token from file oauth.php ******\n");
			fwrite($h, "\r****** Logging from IP: ".$_SERVER['REMOTE_ADDR']." ******\n");
			fwrite($h, "\r****** User_id: ".$user_id." ******\n");
			fwrite($h, "\r****** Project_id: ".$project_id." ******\n\n");
			foreach ($headers as $header => $value) 
			{
				$val = "$header: $value <br />\n";
				fwrite($h, $val);
			}
			

			$token = $server->requestToken();
		} break;
		
		case '/authorize':
		{
			# logon
			//$_SESSION['authorized'] = true;
			assert_logged_in();
			
			//Get the logged in user id from the session.
			$user_id = get_logged_in();
			$project_id = get_project_id();

			
			
			//fwrite($h, "\n\n\n\r**************************************************************************************\n");
			//fwrite($h, "\r****** Date time: ".(date('Y-m-d H:i:s'))." ******\n");
			//fwrite($h, "\r****** Logging incoming headers of POST hitting /authorize from file oauth.php ******\n");
			//fwrite($h, "\r****** Logging from IP: ".$_SERVER['REMOTE_ADDR']." ******\n");
			//fwrite($h, "\r****** User_id: ".$user_id." ******\n");
			//fwrite($h, "\r****** Project_id: ".$project_id." ******\n\n");

			//buscamos datos del usuario
			$headers = getAllHeadersJorge();
			
			$data = explode(':', $headers['Authorization']);
			$data2 = explode(',', $data[0]);
			foreach ($data2 as $val) 
			{
				$valor = explode('=', $val);
				$header2[trim($valor[0])] = stripslashes(str_replace('"', '', trim($valor[1])));
			}
			
			$oauth_token = $header2['oauth_token'];
			//fwrite($h, "****** oauth_token: ".$oauth_token." ******\n");
			
			try
			{
				$server->authorizeVerify();
				$server->authorizeFinish(true, $user_id, $project_id); //Pass the user id to this function.
				
			}
			catch (OAuthException2 $e)
			{
				header('HTTP/1.1 400 Bad Request');
				header('Content-Type: text/plain');
				
				echo "Failed OAuth Request FROM /authorize: " . $e->getMessage();
			}
			
		} break;
	
		case '/access_token':
		{
			//$headers = getAllHeaders_manual();
			
			//fwrite($h, "\n\n\n\r**************************************************************************************\n");
			//fwrite($h, "\r****** Date time: ".(date('Y-m-d H:i:s'))." ******\n");
			//fwrite($h, "\r****** Logging incoming headers of POST hitting /access_token from file oauth.php ******\n");
			//fwrite($h, "\r****** Logging from IP: ".$_SERVER['REMOTE_ADDR']." ******\n");
			//fwrite($h, "\r****** User_id: ".$user_id." ******\n");
			//fwrite($h, "\r****** Project_id: ".$project_id." ******\n\n");
			/*foreach ($headers as $header => $value) 
			{
				$val = "$header: $value <br />\n";
				//fwrite($h, $val);
			}*/
			

			$server->accessToken();
	
			// The current user
			$user_id = get_logged_in();
	
		} break;
		
		default:
		{
			header('HTTP/1.1 500 Internal Server Error');
			header('Content-Type: text/plain');
			echo "Unknown request";
		}
	}
	
	//close LOG file
	fclose($h);
	
	require_once '../core/end.php';

?>