<?php
/**
 * Thankyou page
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/checkout/thankyou.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     2.2.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

//	echo '<pre>';
//	print_r($order);
//	echo '</pre>';

if ( $order ) : ?>

	<?php if ( $order->has_status( 'failed' ) ) : ?>

		<p class="woocommerce-thankyou-order-failed"><?php _e( 'Unfortunately your order cannot be processed as the originating bank/merchant has declined your transaction. Please attempt your purchase again.', 'woocommerce' ); ?></p>

		<p class="woocommerce-thankyou-order-failed-actions">
			<a href="<?php echo esc_url( $order->get_checkout_payment_url() ); ?>" class="button pay"><?php _e( 'Pay', 'woocommerce' ) ?></a>
			<?php if ( is_user_logged_in() ) : ?>
		  <a href="<?php echo esc_url( wc_get_page_permalink( 'myaccount' ) ); ?>" class="button pay"><?php _e( 'My Account', 'woocommerce' ); ?></a>
			<?php endif; ?>
		</p>

	<?php else : ?>

		<p class="woocommerce-thankyou-order-received"><?php echo apply_filters( 'woocommerce_thankyou_order_received_text', __( 'Thank you. Your order has been received.', 'woocommerce' ), $order ); ?></p>

		<ul class="woocommerce-thankyou-order-details order_details">
			<li class="order">
				<?php _e( 'Order Number:', 'woocommerce' ); ?>
				<strong><?php echo $order->get_order_number(); ?></strong>
			</li>
			<li class="date">
				<?php _e( 'Date:', 'woocommerce' ); ?>
				<strong><?php echo date_i18n( get_option( 'date_format' ), strtotime( $order->order_date ) ); ?></strong>
			</li>
			<li class="total">
				<?php _e( 'Total:', 'woocommerce' ); ?>
				<strong><?php echo $order->get_formatted_order_total(); ?></strong>
			</li>
			<?php if ( $order->payment_method_title ) : ?>
			<li class="method">
				<?php _e( 'Payment Method:', 'woocommerce' ); ?>
				<strong><?php echo $order->payment_method_title; ?></strong>
			</li>
			<?php endif; ?>
		</ul>
		<div class="clear"></div>

	<?php
	//NAVARTIC::JORGE - updating order from session
	$item = $order->get_items('line_item');
	if($_SESSION['cart_id'] != ''){
		WC()->session->__unset('cart_nw_id');
		WC()->session->set('cart_nw_id', $_SESSION['cart_id']);
	}
	$cart_nw_id = WC()->session->get('cart_nw_id');
	//echo "<pre>";print_r($cart_nw_id);exit;
	$data = (array) WC()->session->get($cart_nw_id);
	
	//$data = (array) WC()->session->get($_SESSION['cart_id']);
//	print_r($data);

	wc_update_order_item_meta(key($item), __( 'Name', 'hpwallart' ), $data['_name'] );
	wc_update_order_item_meta(key($item), __( 'Width', 'hpwallart' ), $data['_width'] );
	wc_update_order_item_meta(key($item), __( 'Height', 'hpwallart' ), $data['_height'] );
	wc_update_order_item_meta(key($item), __( 'Type', 'hpwallart' ), $data['_type'] );
	wc_update_order_item_meta(key($item), __( 'Category', 'hpwallart' ), $data['_category'] );
	wc_update_order_item_meta(key($item), __( 'Status', 'hpwallart' ), 'PURCHASED' );
	//wc_update_order_item_meta(key($item), __( 'Preview', 'hpwallart' ), '<a target="_blank" href="'.$data['_preview'].'">'.__( 'Preview image', 'hpwallart' ).'</a>' );
	wc_update_order_item_meta(key($item), __( 'Preview', 'hpwallart' ), '<a target="_blank" href="'.$data[$cart_nw_id].'">'.__( 'Preview image', 'hpwallart' ).'</a>' );
	
	wc_update_order_item_meta(key($item), __( '_data', 'hpwallart' ), serialize($_SESSION) );
	wc_update_order_item_meta(key($item), __( '_status', 'hpwallart' ), 'PURCHASED' );
	
	//echo '<img width="200" src="'.$data['_preview'].'" /><p>'.__( 'Preview image', 'hpwallart' ).'</p>';
	echo '<img width="200" src="'.$data[$cart_nw_id].'" /><p>'.__( 'Preview image', 'hpwallart' ).'</p>';
	
	if(count($data['_backgrounds']))
	{
		foreach($data['_backgrounds'] as $k => $val)
		{
			wc_update_order_item_meta(key($item), __( 'Background '.($k+1).' id', 'hpwallart' ), $val['id'] );
			wc_update_order_item_meta(key($item), __( 'Background '.($k+1).' path', 'hpwallart' ), '<a target="_blank" href="'.$val['path'].'">'.__( 'Preview image', 'hpwallart' ).'</a>' );
		}
	}
	
	if(count($data['_objects']))
	{
		foreach($data['_objects'] as $k => $val)
		{
			wc_update_order_item_meta(key($item), __( 'Object '.($k+1).' id', 'hpwallart' ), $val['id'] );
			wc_update_order_item_meta(key($item), __( 'Object '.($k+1).' path', 'hpwallart' ), '<a target="_blank" href="'.$val['path'].'">'.__( 'Preview image', 'hpwallart' ).'</a>' );
		}
	}
	
//	wc_update_order_item_meta(key($item), '_line_total', $data['_line_total']);
//	wc_update_order_item_meta(key($item), '_line_subtotal', $data['_line_subtotal']);

	//update cart price
//	update_post_meta($order->id, '_order_total', $data['_line_subtotal']);

	//Pass the status of project to PLACED in HP Server
	if(count($data))	//once if session data is accesible
	{
		$base_url = get_option('hp_wallart_base_url');
		$url = 'https://store.hpwallart.com/'.$base_url.'/projects/'.$order->get_order_number().'/trigger_rendering';
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, "job_id=".$order->get_order_number()."&barcode_text=lalala&callback_url=");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$remote_server_output = curl_exec($ch);
		curl_close ($ch);
		//echo '<pre>'.print_r($remote_server_output).'</pre>';
	}
	
	//empty cart, order, session, etc.
	//no borramos de la sesion
	//WC()->session->set('_lm_product_data', NULL);
	global $woocommerce;
	$woocommerce->cart->empty_cart();
	unset( $woocommerce->session->order_awaiting_payment );	
	unset($_SESSION["basket"]);
	unset($_SESSION);
	session_destroy();
	$_SESSION['basket']['paso'] = '1';	
	
	

	//end  NAVARTIC
	?>

	<?php endif; ?>

	<?php do_action( 'woocommerce_thankyou_' . $order->payment_method, $order->id ); ?>
	<?php do_action( 'woocommerce_thankyou', $order->id ); ?>

<?php else : ?>

	<p class="woocommerce-thankyou-order-received"><?php echo apply_filters( 'woocommerce_thankyou_order_received_text', __( 'Thank you. Your order has been received.', 'woocommerce' ), null ); ?></p>

<?php endif; ?>